
---------------------------------------------------------------------------------
-------------------------------             -------------------------------------
------------------------------- Index Maint -------------------------------------
-------------------------------             -------------------------------------
---------------------------------------------------------------------------------


USE PRECONDBMaint;
GO
------------------------------------
---------BEGIN Reset tables---------
------------------------------------
TRUNCATE TABLE Minion.IndexSettingsDB;
INSERT Minion.IndexSettingsDB
VALUES
('MinionDefault', NULL, 0, 0, 0, 10, 20, 90, 'ON', NULL, '1', NULL, NULL, 1, 1, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, 1, 60, 'Local', NULL, NULL, 1, NULL, NULL);

TRUNCATE TABLE Minion.IndexSettingsTable;

------------------------------------
---------END Reset tables-----------
------------------------------------

----------There are 2 levels of settings.
SELECT * FROM Minion.IndexSettingsDB
SELECT * FROM Minion.IndexSettingsTable

-------------------------------------------------------------------------
-------------------------------------------------------------------------
------------------BEGIN Change Thresholds for individual DB--------------
-------------------------------------------------------------------------
-------------------------------------------------------------------------
INSERT INTO Minion.IndexSettingsDB ([DBName], [Exclude], [ReindexGroupOrder], [ReindexOrder], [ReorgThreshold], [RebuildThreshold], [FILLFACTORopt], [PadIndex], [ONLINEopt], [SortInTempDB], [MAXDOPopt], [DataCompression], [GetRowCT], [GetPostFragLevel], [UpdateStatsOnDefrag], [StatScanOption], [IgnoreDupKey], [StatsNoRecompute], [AllowRowLocks], [AllowPageLocks], [WaitAtLowPriority], [MaxDurationInMins], [AbortAfterWait], [PushToMinion], [LogIndexPhysicalStats], [IndexScanMode], [DBPreCode], [DBPostCode], [TablePreCode], [TablePostCode], [LogProgress], [LogRetDays], [LogLoc], [MinionTriggerPath], [RecoveryModel], [IncludeUsageDetails]) 
SELECT 'BITFinal' AS [DBName], 0 AS [Exclude], 0 AS [ReindexGroupOrder], 0 AS [ReindexOrder], 30 AS [ReorgThreshold], 45 AS [RebuildThreshold], 90 AS [FILLFACTORopt], 'ON' AS [PadIndex], NULL AS [ONLINEopt], NULL AS [SortInTempDB], NULL AS [MAXDOPopt], NULL AS [DataCompression], 1 AS [GetRowCT], 1 AS [GetPostFragLevel], 1 AS [UpdateStatsOnDefrag], NULL AS [StatScanOption], NULL AS [IgnoreDupKey], NULL AS [StatsNoRecompute], NULL AS [AllowRowLocks], NULL AS [AllowPageLocks], NULL AS [WaitAtLowPriority], NULL AS [MaxDurationInMins], NULL AS [AbortAfterWait], NULL AS [PushToMinion], NULL AS [LogIndexPhysicalStats], NULL AS [IndexScanMode], NULL AS [DBPreCode], NULL AS [DBPostCode], NULL AS [TablePreCode], NULL AS [TablePostCode], 1 AS [LogProgress], 60 AS [LogRetDays], 'Local' AS [LogLoc], NULL AS [MinionTriggerPath], NULL AS [RecoveryModel], 1 AS [IncludeUsageDetails]

SELECT * FROM Minion.IndexSettingsDB;
-------------------------------------------------------------------------
-------------------------------------------------------------------------
------------------END Change Thresholds for individual DB----------------
-------------------------------------------------------------------------
-------------------------------------------------------------------------



-------------------------------------------------------------------------
-------------------------------------------------------------------------
------------------BEGIN Order DBs----------------------------------------
-------------------------------------------------------------------------
-------------------------------------------------------------------------

----------------------------------------------
------------BEGIN Simple Ordering-------------
----------------------------------------------
INSERT INTO Minion.IndexSettingsDB ([DBName], [Exclude], [ReindexGroupOrder], [ReindexOrder], [ReorgThreshold], [RebuildThreshold], [FILLFACTORopt], [PadIndex], [ONLINEopt], [SortInTempDB], [MAXDOPopt], [DataCompression], [GetRowCT], [GetPostFragLevel], [UpdateStatsOnDefrag], [StatScanOption], [IgnoreDupKey], [StatsNoRecompute], [AllowRowLocks], [AllowPageLocks], [WaitAtLowPriority], [MaxDurationInMins], [AbortAfterWait], [PushToMinion], [LogIndexPhysicalStats], [IndexScanMode], [DBPreCode], [DBPostCode], [TablePreCode], [TablePostCode], [LogProgress], [LogRetDays], [LogLoc], [MinionTriggerPath], [RecoveryModel], [IncludeUsageDetails]) 
SELECT 'MinionDev' AS [DBName], 0 AS [Exclude], 15 AS [ReindexGroupOrder], 0 AS [ReindexOrder], 10 AS [ReorgThreshold], 20 AS [RebuildThreshold], 90 AS [FILLFACTORopt], 'ON' AS [PadIndex], NULL AS [ONLINEopt], NULL AS [SortInTempDB], NULL AS [MAXDOPopt], NULL AS [DataCompression], 1 AS [GetRowCT], 1 AS [GetPostFragLevel], 1 AS [UpdateStatsOnDefrag], NULL AS [StatScanOption], NULL AS [IgnoreDupKey], NULL AS [StatsNoRecompute], NULL AS [AllowRowLocks], NULL AS [AllowPageLocks], NULL AS [WaitAtLowPriority], NULL AS [MaxDurationInMins], NULL AS [AbortAfterWait], NULL AS [PushToMinion], NULL AS [LogIndexPhysicalStats], NULL AS [IndexScanMode], NULL AS [DBPreCode], NULL AS [DBPostCode], NULL AS [TablePreCode], NULL AS [TablePostCode], 1 AS [LogProgress], 60 AS [LogRetDays], 'Local' AS [LogLoc], NULL AS [MinionTriggerPath], NULL AS [RecoveryModel], 1 AS [IncludeUsageDetails]

INSERT INTO Minion.IndexSettingsDB ([DBName], [Exclude], [ReindexGroupOrder], [ReindexOrder], [ReorgThreshold], [RebuildThreshold], [FILLFACTORopt], [PadIndex], [ONLINEopt], [SortInTempDB], [MAXDOPopt], [DataCompression], [GetRowCT], [GetPostFragLevel], [UpdateStatsOnDefrag], [StatScanOption], [IgnoreDupKey], [StatsNoRecompute], [AllowRowLocks], [AllowPageLocks], [WaitAtLowPriority], [MaxDurationInMins], [AbortAfterWait], [PushToMinion], [LogIndexPhysicalStats], [IndexScanMode], [DBPreCode], [DBPostCode], [TablePreCode], [TablePostCode], [LogProgress], [LogRetDays], [LogLoc], [MinionTriggerPath], [RecoveryModel], [IncludeUsageDetails]) 
SELECT 'DBStats' AS [DBName], 0 AS [Exclude], 10 AS [ReindexGroupOrder], 0 AS [ReindexOrder], 10 AS [ReorgThreshold], 20 AS [RebuildThreshold], 90 AS [FILLFACTORopt], 'ON' AS [PadIndex], NULL AS [ONLINEopt], NULL AS [SortInTempDB], NULL AS [MAXDOPopt], NULL AS [DataCompression], 1 AS [GetRowCT], 1 AS [GetPostFragLevel], 1 AS [UpdateStatsOnDefrag], NULL AS [StatScanOption], NULL AS [IgnoreDupKey], NULL AS [StatsNoRecompute], NULL AS [AllowRowLocks], NULL AS [AllowPageLocks], NULL AS [WaitAtLowPriority], NULL AS [MaxDurationInMins], NULL AS [AbortAfterWait], NULL AS [PushToMinion], NULL AS [LogIndexPhysicalStats], NULL AS [IndexScanMode], NULL AS [DBPreCode], NULL AS [DBPostCode], NULL AS [TablePreCode], NULL AS [TablePostCode], 1 AS [LogProgress], 60 AS [LogRetDays], 'Local' AS [LogLoc], NULL AS [MinionTriggerPath], NULL AS [RecoveryModel], 1 AS [IncludeUsageDetails]

INSERT INTO Minion.IndexSettingsDB ([DBName], [Exclude], [ReindexGroupOrder], [ReindexOrder], [ReorgThreshold], [RebuildThreshold], [FILLFACTORopt], [PadIndex], [ONLINEopt], [SortInTempDB], [MAXDOPopt], [DataCompression], [GetRowCT], [GetPostFragLevel], [UpdateStatsOnDefrag], [StatScanOption], [IgnoreDupKey], [StatsNoRecompute], [AllowRowLocks], [AllowPageLocks], [WaitAtLowPriority], [MaxDurationInMins], [AbortAfterWait], [PushToMinion], [LogIndexPhysicalStats], [IndexScanMode], [DBPreCode], [DBPostCode], [TablePreCode], [TablePostCode], [LogProgress], [LogRetDays], [LogLoc], [MinionTriggerPath], [RecoveryModel], [IncludeUsageDetails]) 
SELECT 'Minion' AS [DBName], 0 AS [Exclude], 50 AS [ReindexGroupOrder], 0 AS [ReindexOrder], 01 AS [ReorgThreshold], 20 AS [RebuildThreshold], 90 AS [FILLFACTORopt], 'ON' AS [PadIndex], NULL AS [ONLINEopt], NULL AS [SortInTempDB], NULL AS [MAXDOPopt], NULL AS [DataCompression], 1 AS [GetRowCT], 1 AS [GetPostFragLevel], 1 AS [UpdateStatsOnDefrag], NULL AS [StatScanOption], NULL AS [IgnoreDupKey], NULL AS [StatsNoRecompute], NULL AS [AllowRowLocks], NULL AS [AllowPageLocks], NULL AS [WaitAtLowPriority], NULL AS [MaxDurationInMins], NULL AS [AbortAfterWait], NULL AS [PushToMinion], NULL AS [LogIndexPhysicalStats], NULL AS [IndexScanMode], NULL AS [DBPreCode], NULL AS [DBPostCode], NULL AS [TablePreCode], NULL AS [TablePostCode], 1 AS [LogProgress], 60 AS [LogRetDays], 'Local' AS [LogLoc], NULL AS [MinionTriggerPath], NULL AS [RecoveryModel], 1 AS [IncludeUsageDetails]

SELECT * FROM Minion.IndexSettingsDB

[Minion].[IndexMaintMaster] 
	@IndexOption = 'All', -- Valid options: All, ONLINE, OFFLINE
	@ReorgMode = 'All', -- Valid options: All, Reorg, Rebuild
	@RunPrepped = 0, -- Valid options: 1, 0. If you've collected index frag stats ahead of time by running with @PrepOnly = 1, then you can use this option. 
	@PrepOnly = 0, -- Valid options: 1, 0. Allows you to take frag stats earlier in the day and save them for use at a later time.
	@StmtOnly = 1, -- Print the reindex stmts w/o modifying the SP.  This will NOT run any reindex stmts, only PRINT them.
	@Include = NULL, -- Only do DBs listed here. Commas are used. ex: @Include = 'master, model, msdb'
	@Exclude = NULL, -- Do all DBs except the ones listed here. Commas are used. ex: @Exclude = 'master, model, msdb'
	@LogProgress = 1 -- Allows Live Insight through Log tables.
----------------------------------------------
------------BEGIN Simple Ordering-------------
----------------------------------------------


----------------------------------------------
------------BEGIN Sub Ordering----------------
----------------------------------------------

--Here we need to control the ordering even more.  We need to organize the DBs into major groups
--and then into sub-groups.
INSERT INTO Minion.IndexSettingsDB ([DBName], [Exclude], [ReindexGroupOrder], [ReindexOrder], [ReorgThreshold], [RebuildThreshold], [FILLFACTORopt], [PadIndex], [ONLINEopt], [SortInTempDB], [MAXDOPopt], [DataCompression], [GetRowCT], [GetPostFragLevel], [UpdateStatsOnDefrag], [StatScanOption], [IgnoreDupKey], [StatsNoRecompute], [AllowRowLocks], [AllowPageLocks], [WaitAtLowPriority], [MaxDurationInMins], [AbortAfterWait], [PushToMinion], [LogIndexPhysicalStats], [IndexScanMode], [DBPreCode], [DBPostCode], [TablePreCode], [TablePostCode], [LogProgress], [LogRetDays], [LogLoc], [MinionTriggerPath], [RecoveryModel], [IncludeUsageDetails]) 
SELECT 'MB11' AS [DBName], 0 AS [Exclude], 50 AS [ReindexGroupOrder], 10 AS [ReindexOrder], 10 AS [ReorgThreshold], 20 AS [RebuildThreshold], 90 AS [FILLFACTORopt], 'ON' AS [PadIndex], NULL AS [ONLINEopt], NULL AS [SortInTempDB], NULL AS [MAXDOPopt], NULL AS [DataCompression], 1 AS [GetRowCT], 1 AS [GetPostFragLevel], 1 AS [UpdateStatsOnDefrag], NULL AS [StatScanOption], NULL AS [IgnoreDupKey], NULL AS [StatsNoRecompute], NULL AS [AllowRowLocks], NULL AS [AllowPageLocks], NULL AS [WaitAtLowPriority], NULL AS [MaxDurationInMins], NULL AS [AbortAfterWait], NULL AS [PushToMinion], NULL AS [LogIndexPhysicalStats], NULL AS [IndexScanMode], NULL AS [DBPreCode], NULL AS [DBPostCode], NULL AS [TablePreCode], NULL AS [TablePostCode], 1 AS [LogProgress], 60 AS [LogRetDays], 'Local' AS [LogLoc], NULL AS [MinionTriggerPath], NULL AS [RecoveryModel], 1 AS [IncludeUsageDetails]

INSERT INTO Minion.IndexSettingsDB ([DBName], [Exclude], [ReindexGroupOrder], [ReindexOrder], [ReorgThreshold], [RebuildThreshold], [FILLFACTORopt], [PadIndex], [ONLINEopt], [SortInTempDB], [MAXDOPopt], [DataCompression], [GetRowCT], [GetPostFragLevel], [UpdateStatsOnDefrag], [StatScanOption], [IgnoreDupKey], [StatsNoRecompute], [AllowRowLocks], [AllowPageLocks], [WaitAtLowPriority], [MaxDurationInMins], [AbortAfterWait], [PushToMinion], [LogIndexPhysicalStats], [IndexScanMode], [DBPreCode], [DBPostCode], [TablePreCode], [TablePostCode], [LogProgress], [LogRetDays], [LogLoc], [MinionTriggerPath], [RecoveryModel], [IncludeUsageDetails]) 
SELECT 'MB12' AS [DBName], 0 AS [Exclude], 50 AS [ReindexGroupOrder], 9 AS [ReindexOrder], 10 AS [ReorgThreshold], 20 AS [RebuildThreshold], 90 AS [FILLFACTORopt], 'ON' AS [PadIndex], NULL AS [ONLINEopt], NULL AS [SortInTempDB], NULL AS [MAXDOPopt], NULL AS [DataCompression], 1 AS [GetRowCT], 1 AS [GetPostFragLevel], 1 AS [UpdateStatsOnDefrag], NULL AS [StatScanOption], NULL AS [IgnoreDupKey], NULL AS [StatsNoRecompute], NULL AS [AllowRowLocks], NULL AS [AllowPageLocks], NULL AS [WaitAtLowPriority], NULL AS [MaxDurationInMins], NULL AS [AbortAfterWait], NULL AS [PushToMinion], NULL AS [LogIndexPhysicalStats], NULL AS [IndexScanMode], NULL AS [DBPreCode], NULL AS [DBPostCode], NULL AS [TablePreCode], NULL AS [TablePostCode], 1 AS [LogProgress], 60 AS [LogRetDays], 'Local' AS [LogLoc], NULL AS [MinionTriggerPath], NULL AS [RecoveryModel], 1 AS [IncludeUsageDetails]

INSERT INTO Minion.IndexSettingsDB ([DBName], [Exclude], [ReindexGroupOrder], [ReindexOrder], [ReorgThreshold], [RebuildThreshold], [FILLFACTORopt], [PadIndex], [ONLINEopt], [SortInTempDB], [MAXDOPopt], [DataCompression], [GetRowCT], [GetPostFragLevel], [UpdateStatsOnDefrag], [StatScanOption], [IgnoreDupKey], [StatsNoRecompute], [AllowRowLocks], [AllowPageLocks], [WaitAtLowPriority], [MaxDurationInMins], [AbortAfterWait], [PushToMinion], [LogIndexPhysicalStats], [IndexScanMode], [DBPreCode], [DBPostCode], [TablePreCode], [TablePostCode], [LogProgress], [LogRetDays], [LogLoc], [MinionTriggerPath], [RecoveryModel], [IncludeUsageDetails]) 
SELECT 'JenDemo' AS [DBName], 0 AS [Exclude], 50 AS [ReindexGroupOrder], 8 AS [ReindexOrder], 01 AS [ReorgThreshold], 20 AS [RebuildThreshold], 90 AS [FILLFACTORopt], 'ON' AS [PadIndex], NULL AS [ONLINEopt], NULL AS [SortInTempDB], NULL AS [MAXDOPopt], NULL AS [DataCompression], 1 AS [GetRowCT], 1 AS [GetPostFragLevel], 1 AS [UpdateStatsOnDefrag], NULL AS [StatScanOption], NULL AS [IgnoreDupKey], NULL AS [StatsNoRecompute], NULL AS [AllowRowLocks], NULL AS [AllowPageLocks], NULL AS [WaitAtLowPriority], NULL AS [MaxDurationInMins], NULL AS [AbortAfterWait], NULL AS [PushToMinion], NULL AS [LogIndexPhysicalStats], NULL AS [IndexScanMode], NULL AS [DBPreCode], NULL AS [DBPostCode], NULL AS [TablePreCode], NULL AS [TablePostCode], 1 AS [LogProgress], 60 AS [LogRetDays], 'Local' AS [LogLoc], NULL AS [MinionTriggerPath], NULL AS [RecoveryModel], 1 AS [IncludeUsageDetails]

INSERT INTO Minion.IndexSettingsDB ([DBName], [Exclude], [ReindexGroupOrder], [ReindexOrder], [ReorgThreshold], [RebuildThreshold], [FILLFACTORopt], [PadIndex], [ONLINEopt], [SortInTempDB], [MAXDOPopt], [DataCompression], [GetRowCT], [GetPostFragLevel], [UpdateStatsOnDefrag], [StatScanOption], [IgnoreDupKey], [StatsNoRecompute], [AllowRowLocks], [AllowPageLocks], [WaitAtLowPriority], [MaxDurationInMins], [AbortAfterWait], [PushToMinion], [LogIndexPhysicalStats], [IndexScanMode], [DBPreCode], [DBPostCode], [TablePreCode], [TablePostCode], [LogProgress], [LogRetDays], [LogLoc], [MinionTriggerPath], [RecoveryModel], [IncludeUsageDetails]) 
SELECT 'Demo' AS [DBName], 0 AS [Exclude], 10 AS [ReindexGroupOrder], 10 AS [ReindexOrder], 01 AS [ReorgThreshold], 20 AS [RebuildThreshold], 90 AS [FILLFACTORopt], 'ON' AS [PadIndex], NULL AS [ONLINEopt], NULL AS [SortInTempDB], NULL AS [MAXDOPopt], NULL AS [DataCompression], 1 AS [GetRowCT], 1 AS [GetPostFragLevel], 1 AS [UpdateStatsOnDefrag], NULL AS [StatScanOption], NULL AS [IgnoreDupKey], NULL AS [StatsNoRecompute], NULL AS [AllowRowLocks], NULL AS [AllowPageLocks], NULL AS [WaitAtLowPriority], NULL AS [MaxDurationInMins], NULL AS [AbortAfterWait], NULL AS [PushToMinion], NULL AS [LogIndexPhysicalStats], NULL AS [IndexScanMode], NULL AS [DBPreCode], NULL AS [DBPostCode], NULL AS [TablePreCode], NULL AS [TablePostCode], 1 AS [LogProgress], 60 AS [LogRetDays], 'Local' AS [LogLoc], NULL AS [MinionTriggerPath], NULL AS [RecoveryModel], 1 AS [IncludeUsageDetails]

INSERT INTO Minion.IndexSettingsDB ([DBName], [Exclude], [ReindexGroupOrder], [ReindexOrder], [ReorgThreshold], [RebuildThreshold], [FILLFACTORopt], [PadIndex], [ONLINEopt], [SortInTempDB], [MAXDOPopt], [DataCompression], [GetRowCT], [GetPostFragLevel], [UpdateStatsOnDefrag], [StatScanOption], [IgnoreDupKey], [StatsNoRecompute], [AllowRowLocks], [AllowPageLocks], [WaitAtLowPriority], [MaxDurationInMins], [AbortAfterWait], [PushToMinion], [LogIndexPhysicalStats], [IndexScanMode], [DBPreCode], [DBPostCode], [TablePreCode], [TablePostCode], [LogProgress], [LogRetDays], [LogLoc], [MinionTriggerPath], [RecoveryModel], [IncludeUsageDetails]) 
SELECT 'MBTestSean' AS [DBName], 0 AS [Exclude], 10 AS [ReindexGroupOrder], 9 AS [ReindexOrder], 01 AS [ReorgThreshold], 20 AS [RebuildThreshold], 90 AS [FILLFACTORopt], 'ON' AS [PadIndex], NULL AS [ONLINEopt], NULL AS [SortInTempDB], NULL AS [MAXDOPopt], NULL AS [DataCompression], 1 AS [GetRowCT], 1 AS [GetPostFragLevel], 1 AS [UpdateStatsOnDefrag], NULL AS [StatScanOption], NULL AS [IgnoreDupKey], NULL AS [StatsNoRecompute], NULL AS [AllowRowLocks], NULL AS [AllowPageLocks], NULL AS [WaitAtLowPriority], NULL AS [MaxDurationInMins], NULL AS [AbortAfterWait], NULL AS [PushToMinion], NULL AS [LogIndexPhysicalStats], NULL AS [IndexScanMode], NULL AS [DBPreCode], NULL AS [DBPostCode], NULL AS [TablePreCode], NULL AS [TablePostCode], 1 AS [LogProgress], 60 AS [LogRetDays], 'Local' AS [LogLoc], NULL AS [MinionTriggerPath], NULL AS [RecoveryModel], 1 AS [IncludeUsageDetails]

INSERT INTO Minion.IndexSettingsDB ([DBName], [Exclude], [ReindexGroupOrder], [ReindexOrder], [ReorgThreshold], [RebuildThreshold], [FILLFACTORopt], [PadIndex], [ONLINEopt], [SortInTempDB], [MAXDOPopt], [DataCompression], [GetRowCT], [GetPostFragLevel], [UpdateStatsOnDefrag], [StatScanOption], [IgnoreDupKey], [StatsNoRecompute], [AllowRowLocks], [AllowPageLocks], [WaitAtLowPriority], [MaxDurationInMins], [AbortAfterWait], [PushToMinion], [LogIndexPhysicalStats], [IndexScanMode], [DBPreCode], [DBPostCode], [TablePreCode], [TablePostCode], [LogProgress], [LogRetDays], [LogLoc], [MinionTriggerPath], [RecoveryModel], [IncludeUsageDetails]) 
SELECT 'CDC' AS [DBName], 0 AS [Exclude], 10 AS [ReindexGroupOrder], 8 AS [ReindexOrder], 01 AS [ReorgThreshold], 20 AS [RebuildThreshold], 90 AS [FILLFACTORopt], 'ON' AS [PadIndex], NULL AS [ONLINEopt], NULL AS [SortInTempDB], NULL AS [MAXDOPopt], NULL AS [DataCompression], 1 AS [GetRowCT], 1 AS [GetPostFragLevel], 1 AS [UpdateStatsOnDefrag], NULL AS [StatScanOption], NULL AS [IgnoreDupKey], NULL AS [StatsNoRecompute], NULL AS [AllowRowLocks], NULL AS [AllowPageLocks], NULL AS [WaitAtLowPriority], NULL AS [MaxDurationInMins], NULL AS [AbortAfterWait], NULL AS [PushToMinion], NULL AS [LogIndexPhysicalStats], NULL AS [IndexScanMode], NULL AS [DBPreCode], NULL AS [DBPostCode], NULL AS [TablePreCode], NULL AS [TablePostCode], 1 AS [LogProgress], 60 AS [LogRetDays], 'Local' AS [LogLoc], NULL AS [MinionTriggerPath], NULL AS [RecoveryModel], 1 AS [IncludeUsageDetails]

SELECT * FROM Minion.IndexSettingsDB

EXEC [Minion].[IndexMaintMaster] 
	@IndexOption = 'All', -- Valid options: All, ONLINE, OFFLINE
	@ReorgMode = 'All', -- Valid options: All, Reorg, Rebuild
	@RunPrepped = 0, -- Valid options: 1, 0. If you've collected index frag stats ahead of time by running with @PrepOnly = 1, then you can use this option. 
	@PrepOnly = 0, -- Valid options: 1, 0. Allows you to take frag stats earlier in the day and save them for use at a later time.
	@StmtOnly = 1, -- Print the reindex stmts w/o modifying the SP.  This will NOT run any reindex stmts, only PRINT them.
	@Include = NULL, -- Only do DBs listed here. Commas are used. ex: @Include = 'master, model, msdb'
	@Exclude = NULL, -- Do all DBs except the ones listed here. Commas are used. ex: @Exclude = 'master, model, msdb'
	@LogProgress = 1 -- Allows Live Insight through Log tables.

----Now CDC needs to be at the top of its group.
UPDATE Minion.IndexSettingsDB
SET ReindexOrder = 11
WHERE DBName = 'CDC'

EXEC [Minion].[IndexMaintMaster] 
	@IndexOption = 'All', -- Valid options: All, ONLINE, OFFLINE
	@ReorgMode = 'All', -- Valid options: All, Reorg, Rebuild
	@RunPrepped = 0, -- Valid options: 1, 0. If you've collected index frag stats ahead of time by running with @PrepOnly = 1, then you can use this option. 
	@PrepOnly = 0, -- Valid options: 1, 0. Allows you to take frag stats earlier in the day and save them for use at a later time.
	@StmtOnly = 1, -- Print the reindex stmts w/o modifying the SP.  This will NOT run any reindex stmts, only PRINT them.
	@Include = NULL, -- Only do DBs listed here. Commas are used. ex: @Include = 'master, model, msdb'
	@Exclude = NULL, -- Do all DBs except the ones listed here. Commas are used. ex: @Exclude = 'master, model, msdb'
	@LogProgress = 1 -- Allows Live Insight through Log tables.

----------------------------------------------
------------BEGIN Sub Ordering----------------
----------------------------------------------


-------------------------------------------------------------------------
-------------------------------------------------------------------------
------------------END Order DBs------------------------------------------
-------------------------------------------------------------------------
-------------------------------------------------------------------------



-------------------------------------------------------------------------
-------------------------------------------------------------------------
------------------BEGIN Order Tables-------------------------------------
-------------------------------------------------------------------------
-------------------------------------------------------------------------

----------------------------------------------
------------BEGIN Simple Ordering-------------
----------------------------------------------
--This is am important one because not being able to order objects is quite often the cause for
--tight maint windows.  It's seldom that the maint window has an actual hard stop at say 2hrs and 
--no more maint can be done.  Most of the time it's the core tables that need to be done by that time,
--and the rest of them can still be processed because they're not used much and they're much smaller.

INSERT INTO Minion.IndexSettingsTable ([DBName], [SchemaName], [TableName], [Exclude], [ReindexGroupOrder], [ReindexOrder], [ReorgThreshold], [RebuildThreshold], [FILLFACTORopt], [PadIndex], [ONLINEopt], [SortInTempDB], [MAXDOPopt], [DataCompression], [GetRowCT], [GetPostFragLevel], [UpdateStatsOnDefrag], [StatScanOption], [IgnoreDupKey], [StatsNoRecompute], [AllowRowLocks], [AllowPageLocks], [WaitAtLowPriority], [MaxDurationInMins], [AbortAfterWait], [PushToMinion], [LogIndexPhysicalStats], [IndexScanMode], [TablePreCode], [TablePostCode], [LogProgress], [LogRetDays], [PartitionReindex], [isLOB], [TableType], [IncludeUsageDetails]) 
SELECT 'Minion' AS [DBName],
'Collector' AS [SchemaName],
'ServerPermissions' AS [TableName],
0 AS [Exclude],
10 AS [ReindexGroupOrder],
0 AS [ReindexOrder],
1 AS [ReorgThreshold],
10 AS [RebuildThreshold],
75 AS [FILLFACTORopt],
'ON' AS [PadIndex],
'ON' AS [ONLINEopt],
'ON' AS [SortInTempDB],
NULL AS [MAXDOPopt],
NULL AS [DataCompression],
1 AS [GetRowCT],
1 AS [GetPostFragLevel],
1 AS [UpdateStatsOnDefrag],
NULL AS [StatScanOption],
NULL AS [IgnoreDupKey],
NULL AS [StatsNoRecompute],
NULL AS [AllowRowLocks],
NULL AS [AllowPageLocks],
NULL AS [WaitAtLowPriority],
NULL AS [MaxDurationInMins],
NULL AS [AbortAfterWait],
NULL AS [PushToMinion],
NULL AS [LogIndexPhysicalStats],
NULL AS [IndexScanMode],
NULL AS [TablePreCode],
NULL AS [TablePostCode],
NULL AS [LogProgress],
NULL AS [LogRetDays],
NULL AS [PartitionReindex],
NULL AS [isLOB],
NULL AS [TableType],
1 AS [IncludeUsageDetails]

INSERT INTO Minion.IndexSettingsTable ([DBName], [SchemaName], [TableName], [Exclude], [ReindexGroupOrder], [ReindexOrder], [ReorgThreshold], [RebuildThreshold], [FILLFACTORopt], [PadIndex], [ONLINEopt], [SortInTempDB], [MAXDOPopt], [DataCompression], [GetRowCT], [GetPostFragLevel], [UpdateStatsOnDefrag], [StatScanOption], [IgnoreDupKey], [StatsNoRecompute], [AllowRowLocks], [AllowPageLocks], [WaitAtLowPriority], [MaxDurationInMins], [AbortAfterWait], [PushToMinion], [LogIndexPhysicalStats], [IndexScanMode], [TablePreCode], [TablePostCode], [LogProgress], [LogRetDays], [PartitionReindex], [isLOB], [TableType], [IncludeUsageDetails]) 
SELECT 'Minion' AS [DBName],
'Collector' AS [SchemaName],
'ServiceAcct' AS [TableName],
0 AS [Exclude],
5 AS [ReindexGroupOrder],
0 AS [ReindexOrder],
1 AS [ReorgThreshold],
10 AS [RebuildThreshold],
75 AS [FILLFACTORopt],
'ON' AS [PadIndex],
'ON' AS [ONLINEopt],
'ON' AS [SortInTempDB],
NULL AS [MAXDOPopt],
NULL AS [DataCompression],
1 AS [GetRowCT],
1 AS [GetPostFragLevel],
1 AS [UpdateStatsOnDefrag],
NULL AS [StatScanOption],
NULL AS [IgnoreDupKey],
NULL AS [StatsNoRecompute],
NULL AS [AllowRowLocks],
NULL AS [AllowPageLocks],
NULL AS [WaitAtLowPriority],
NULL AS [MaxDurationInMins],
NULL AS [AbortAfterWait],
NULL AS [PushToMinion],
NULL AS [LogIndexPhysicalStats],
NULL AS [IndexScanMode],
NULL AS [TablePreCode],
NULL AS [TablePostCode],
NULL AS [LogProgress],
NULL AS [LogRetDays],
NULL AS [PartitionReindex],
NULL AS [isLOB],
NULL AS [TableType],
1 AS [IncludeUsageDetails]

INSERT INTO Minion.IndexSettingsTable ([DBName], [SchemaName], [TableName], [Exclude], [ReindexGroupOrder], [ReindexOrder], [ReorgThreshold], [RebuildThreshold], [FILLFACTORopt], [PadIndex], [ONLINEopt], [SortInTempDB], [MAXDOPopt], [DataCompression], [GetRowCT], [GetPostFragLevel], [UpdateStatsOnDefrag], [StatScanOption], [IgnoreDupKey], [StatsNoRecompute], [AllowRowLocks], [AllowPageLocks], [WaitAtLowPriority], [MaxDurationInMins], [AbortAfterWait], [PushToMinion], [LogIndexPhysicalStats], [IndexScanMode], [TablePreCode], [TablePostCode], [LogProgress], [LogRetDays], [PartitionReindex], [isLOB], [TableType], [IncludeUsageDetails]) 
SELECT 'Minion' AS [DBName],
'dbo' AS [SchemaName],
'InstanceConfigValue' AS [TableName],
0 AS [Exclude],
4 AS [ReindexGroupOrder],
0 AS [ReindexOrder],
1 AS [ReorgThreshold],
10 AS [RebuildThreshold],
75 AS [FILLFACTORopt],
'ON' AS [PadIndex],
'ON' AS [ONLINEopt],
'ON' AS [SortInTempDB],
NULL AS [MAXDOPopt],
NULL AS [DataCompression],
1 AS [GetRowCT],
1 AS [GetPostFragLevel],
1 AS [UpdateStatsOnDefrag],
NULL AS [StatScanOption],
NULL AS [IgnoreDupKey],
NULL AS [StatsNoRecompute],
NULL AS [AllowRowLocks],
NULL AS [AllowPageLocks],
NULL AS [WaitAtLowPriority],
NULL AS [MaxDurationInMins],
NULL AS [AbortAfterWait],
NULL AS [PushToMinion],
NULL AS [LogIndexPhysicalStats],
NULL AS [IndexScanMode],
NULL AS [TablePreCode],
NULL AS [TablePostCode],
NULL AS [LogProgress],
NULL AS [LogRetDays],
NULL AS [PartitionReindex],
NULL AS [isLOB],
NULL AS [TableType],
1 AS [IncludeUsageDetails]

SELECT * FROM Minion.IndexSettingsTable;

EXEC Minion.IndexMaintDB @DBName = 'Minion', @IndexOption = 'All', @ReorgMode = 'All',  @RunPrepped = 0,  @PrepOnly = 0, @StmtOnly = 1, @LogProgress = 1

UPDATE Minion.IndexSettingsTable
SET ReindexGroupOrder = 11
WHERE TableName = 'InstanceConfigValue'

EXEC Minion.IndexMaintDB @DBName = 'Minion', @IndexOption = 'All', @ReorgMode = 'All',  @RunPrepped = 0,  @PrepOnly = 0, @StmtOnly = 1, @LogProgress = 1

----------------------------------------------
------------END Simple Ordering---------------
----------------------------------------------


----------------------------------------------
------------BEGIN Sub Ordering----------------
----------------------------------------------

INSERT INTO Minion.IndexSettingsTable ([DBName], [SchemaName], [TableName], [Exclude], [ReindexGroupOrder], [ReindexOrder], [ReorgThreshold], [RebuildThreshold], [FILLFACTORopt], [PadIndex], [ONLINEopt], [SortInTempDB], [MAXDOPopt], [DataCompression], [GetRowCT], [GetPostFragLevel], [UpdateStatsOnDefrag], [StatScanOption], [IgnoreDupKey], [StatsNoRecompute], [AllowRowLocks], [AllowPageLocks], [WaitAtLowPriority], [MaxDurationInMins], [AbortAfterWait], [PushToMinion], [LogIndexPhysicalStats], [IndexScanMode], [TablePreCode], [TablePostCode], [LogProgress], [LogRetDays], [PartitionReindex], [isLOB], [TableType], [IncludeUsageDetails]) 
SELECT 'Minion' AS [DBName],
'Collector' AS [SchemaName],
'LoginsDEMO' AS [TableName],
0 AS [Exclude],
10 AS [ReindexGroupOrder],
10 AS [ReindexOrder],
5 AS [ReorgThreshold],
10 AS [RebuildThreshold],
75 AS [FILLFACTORopt],
'ON' AS [PadIndex],
'ON' AS [ONLINEopt],
'ON' AS [SortInTempDB],
NULL AS [MAXDOPopt],
NULL AS [DataCompression],
1 AS [GetRowCT],
1 AS [GetPostFragLevel],
1 AS [UpdateStatsOnDefrag],
NULL AS [StatScanOption],
NULL AS [IgnoreDupKey],
NULL AS [StatsNoRecompute],
NULL AS [AllowRowLocks],
NULL AS [AllowPageLocks],
NULL AS [WaitAtLowPriority],
NULL AS [MaxDurationInMins],
NULL AS [AbortAfterWait],
NULL AS [PushToMinion],
NULL AS [LogIndexPhysicalStats],
NULL AS [IndexScanMode],
NULL AS [TablePreCode],
NULL AS [TablePostCode],
NULL AS [LogProgress],
NULL AS [LogRetDays],
NULL AS [PartitionReindex],
NULL AS [isLOB],
NULL AS [TableType],
1 AS [IncludeUsageDetails]

INSERT INTO Minion.IndexSettingsTable ([DBName], [SchemaName], [TableName], [Exclude], [ReindexGroupOrder], [ReindexOrder], [ReorgThreshold], [RebuildThreshold], [FILLFACTORopt], [PadIndex], [ONLINEopt], [SortInTempDB], [MAXDOPopt], [DataCompression], [GetRowCT], [GetPostFragLevel], [UpdateStatsOnDefrag], [StatScanOption], [IgnoreDupKey], [StatsNoRecompute], [AllowRowLocks], [AllowPageLocks], [WaitAtLowPriority], [MaxDurationInMins], [AbortAfterWait], [PushToMinion], [LogIndexPhysicalStats], [IndexScanMode], [TablePreCode], [TablePostCode], [LogProgress], [LogRetDays], [PartitionReindex], [isLOB], [TableType], [IncludeUsageDetails]) 
SELECT 'Minion' AS [DBName],
'dbo' AS [SchemaName],
'Servers' AS [TableName],
0 AS [Exclude],
10 AS [ReindexGroupOrder],
9 AS [ReindexOrder],
5 AS [ReorgThreshold],
10 AS [RebuildThreshold],
75 AS [FILLFACTORopt],
'ON' AS [PadIndex],
'ON' AS [ONLINEopt],
'ON' AS [SortInTempDB],
NULL AS [MAXDOPopt],
NULL AS [DataCompression],
1 AS [GetRowCT],
1 AS [GetPostFragLevel],
1 AS [UpdateStatsOnDefrag],
NULL AS [StatScanOption],
NULL AS [IgnoreDupKey],
NULL AS [StatsNoRecompute],
NULL AS [AllowRowLocks],
NULL AS [AllowPageLocks],
NULL AS [WaitAtLowPriority],
NULL AS [MaxDurationInMins],
NULL AS [AbortAfterWait],
NULL AS [PushToMinion],
NULL AS [LogIndexPhysicalStats],
NULL AS [IndexScanMode],
NULL AS [TablePreCode],
NULL AS [TablePostCode],
NULL AS [LogProgress],
NULL AS [LogRetDays],
NULL AS [PartitionReindex],
NULL AS [isLOB],
NULL AS [TableType],
1 AS [IncludeUsageDetails]

INSERT INTO Minion.IndexSettingsTable ([DBName], [SchemaName], [TableName], [Exclude], [ReindexGroupOrder], [ReindexOrder], [ReorgThreshold], [RebuildThreshold], [FILLFACTORopt], [PadIndex], [ONLINEopt], [SortInTempDB], [MAXDOPopt], [DataCompression], [GetRowCT], [GetPostFragLevel], [UpdateStatsOnDefrag], [StatScanOption], [IgnoreDupKey], [StatsNoRecompute], [AllowRowLocks], [AllowPageLocks], [WaitAtLowPriority], [MaxDurationInMins], [AbortAfterWait], [PushToMinion], [LogIndexPhysicalStats], [IndexScanMode], [TablePreCode], [TablePostCode], [LogProgress], [LogRetDays], [PartitionReindex], [isLOB], [TableType], [IncludeUsageDetails]) 
SELECT 'Minion' AS [DBName],
'dbo' AS [SchemaName],
'SIDServer' AS [TableName],
0 AS [Exclude],
10 AS [ReindexGroupOrder],
8 AS [ReindexOrder],
5 AS [ReorgThreshold],
10 AS [RebuildThreshold],
75 AS [FILLFACTORopt],
'ON' AS [PadIndex],
'ON' AS [ONLINEopt],
'ON' AS [SortInTempDB],
NULL AS [MAXDOPopt],
NULL AS [DataCompression],
1 AS [GetRowCT],
1 AS [GetPostFragLevel],
1 AS [UpdateStatsOnDefrag],
NULL AS [StatScanOption],
NULL AS [IgnoreDupKey],
NULL AS [StatsNoRecompute],
NULL AS [AllowRowLocks],
NULL AS [AllowPageLocks],
NULL AS [WaitAtLowPriority],
NULL AS [MaxDurationInMins],
NULL AS [AbortAfterWait],
NULL AS [PushToMinion],
NULL AS [LogIndexPhysicalStats],
NULL AS [IndexScanMode],
NULL AS [TablePreCode],
NULL AS [TablePostCode],
NULL AS [LogProgress],
NULL AS [LogRetDays],
NULL AS [PartitionReindex],
NULL AS [isLOB],
NULL AS [TableType],
1 AS [IncludeUsageDetails]

INSERT INTO Minion.IndexSettingsTable ([DBName], [SchemaName], [TableName], [Exclude], [ReindexGroupOrder], [ReindexOrder], [ReorgThreshold], [RebuildThreshold], [FILLFACTORopt], [PadIndex], [ONLINEopt], [SortInTempDB], [MAXDOPopt], [DataCompression], [GetRowCT], [GetPostFragLevel], [UpdateStatsOnDefrag], [StatScanOption], [IgnoreDupKey], [StatsNoRecompute], [AllowRowLocks], [AllowPageLocks], [WaitAtLowPriority], [MaxDurationInMins], [AbortAfterWait], [PushToMinion], [LogIndexPhysicalStats], [IndexScanMode], [TablePreCode], [TablePostCode], [LogProgress], [LogRetDays], [PartitionReindex], [isLOB], [TableType], [IncludeUsageDetails]) 
SELECT 'Minion' AS [DBName],
'Collector' AS [SchemaName],
'Databases' AS [TableName],
0 AS [Exclude],
5 AS [ReindexGroupOrder],
10 AS [ReindexOrder],
1 AS [ReorgThreshold],
10 AS [RebuildThreshold],
75 AS [FILLFACTORopt],
'ON' AS [PadIndex],
'ON' AS [ONLINEopt],
'ON' AS [SortInTempDB],
NULL AS [MAXDOPopt],
NULL AS [DataCompression],
1 AS [GetRowCT],
1 AS [GetPostFragLevel],
1 AS [UpdateStatsOnDefrag],
NULL AS [StatScanOption],
NULL AS [IgnoreDupKey],
NULL AS [StatsNoRecompute],
NULL AS [AllowRowLocks],
NULL AS [AllowPageLocks],
NULL AS [WaitAtLowPriority],
NULL AS [MaxDurationInMins],
NULL AS [AbortAfterWait],
NULL AS [PushToMinion],
NULL AS [LogIndexPhysicalStats],
NULL AS [IndexScanMode],
NULL AS [TablePreCode],
NULL AS [TablePostCode],
NULL AS [LogProgress],
NULL AS [LogRetDays],
NULL AS [PartitionReindex],
NULL AS [isLOB],
NULL AS [TableType],
1 AS [IncludeUsageDetails]

SELECT * FROM Minion.IndexSettingsTable;

UPDATE Minion.IndexSettingsTable 
SET ReorgThreshold = 99,
	RebuildThreshold = 100
WHERE TableName = 'Fragment2'

EXEC Minion.IndexMaintDB @DBName = 'Minion', @IndexOption = 'All', @ReorgMode = 'All',  @RunPrepped = 0,  @PrepOnly = 0, @StmtOnly = 1, @LogProgress = 1

----------------------------------------------
------------END Sub Ordering------------------
----------------------------------------------


-------------------------------------------------------------------------
-------------------------------------------------------------------------
------------------END Order Tables---------------------------------------
-------------------------------------------------------------------------
-------------------------------------------------------------------------



-------------------------------------------------------------------------
-------------------------------------------------------------------------
------------------BEGIN Exclusions---------------------------------------
-------------------------------------------------------------------------
-------------------------------------------------------------------------

----------------------------------------------
------------BEGIN Exclude DBs-----------------
----------------------------------------------
SELECT * FROM Minion.IndexSettingsDB;

EXEC [Minion].[IndexMaintMaster] 
	@IndexOption = 'All', -- Valid options: All, ONLINE, OFFLINE
	@ReorgMode = 'All', -- Valid options: All, Reorg, Rebuild
	@RunPrepped = 0, -- Valid options: 1, 0. If you've collected index frag stats ahead of time by running with @PrepOnly = 1, then you can use this option. 
	@PrepOnly = 0, -- Valid options: 1, 0. Allows you to take frag stats earlier in the day and save them for use at a later time.
	@StmtOnly = 1, -- Print the reindex stmts w/o modifying the SP.  This will NOT run any reindex stmts, only PRINT them.
	@Include = NULL, -- Only do DBs listed here. Commas are used. ex: @Include = 'master, model, msdb'
	@Exclude = NULL, -- Do all DBs except the ones listed here. Commas are used. ex: @Exclude = 'master, model, msdb'
	@LogProgress = 1 -- Allows Live Insight through Log tables.

UPDATE Minion.IndexSettingsDB
SET Exclude = 1
WHERE DBName IN ('MB11', 'MB12')

EXEC [Minion].[IndexMaintMaster] 
	@IndexOption = 'All', -- Valid options: All, ONLINE, OFFLINE
	@ReorgMode = 'All', -- Valid options: All, Reorg, Rebuild
	@RunPrepped = 0, -- Valid options: 1, 0. If you've collected index frag stats ahead of time by running with @PrepOnly = 1, then you can use this option. 
	@PrepOnly = 0, -- Valid options: 1, 0. Allows you to take frag stats earlier in the day and save them for use at a later time.
	@StmtOnly = 1, -- Print the reindex stmts w/o modifying the SP.  This will NOT run any reindex stmts, only PRINT them.
	@Include = NULL, -- Only do DBs listed here. Commas are used. ex: @Include = 'master, model, msdb'
	@Exclude = NULL, -- Do all DBs except the ones listed here. Commas are used. ex: @Exclude = 'master, model, msdb'
	@LogProgress = 1 -- Allows Live Insight through Log tables.
----------------------------------------------
------------END Exclude DBs-------------------
----------------------------------------------


----------------------------------------------
------------BEGIN Exclude Tables--------------
----------------------------------------------
SELECT * FROM Minion.IndexSettingsTable;

EXEC Minion.IndexMaintDB @DBName = 'Minion', @IndexOption = 'All', @ReorgMode = 'All',  @RunPrepped = 0,  @PrepOnly = 0, @StmtOnly = 1, @LogProgress = 1

UPDATE Minion.IndexSettingsTable
SET Exclude = 1
WHERE 
DBName = 'Minion' AND
TableName IN ('InstanceConfigValue', 'LoginsDEMO')

EXEC Minion.IndexMaintDB @DBName = 'Minion', @IndexOption = 'All', @ReorgMode = 'All',  @RunPrepped = 0,  @PrepOnly = 0, @StmtOnly = 1, @LogProgress = 1

----------------------------------------------
------------END Exclude Tables----------------
----------------------------------------------

-------------------------------------------------------------------------
-------------------------------------------------------------------------
------------------END Exclusions-----------------------------------------
-------------------------------------------------------------------------
-------------------------------------------------------------------------



-------------------------------------------------------------------------
-------------------------------------------------------------------------
------------------BEGIN Maximize Maint Window----------------------------
-------------------------------------------------------------------------
-------------------------------------------------------------------------

--The issue here is we've got a tight maint window and the DB is having trouble
--processing in time.  So we need to maximize the maint window in such a way that
--the entire window is used for the reindexing instead of having part of it being taken up
--with the frag stats.  Frag stats can take a long time to gather so using PrepOnly can really help.

SELECT * FROM Minion.IndexTableFrag;
TRUNCATE TABLE Minion.IndexTableFrag;

EXEC [Minion].[IndexMaintMaster] 
	@IndexOption = 'All', -- Valid options: All, ONLINE, OFFLINE
	@ReorgMode = 'All', -- Valid options: All, Reorg, Rebuild
	@RunPrepped = 0, -- Valid options: 1, 0. If you've collected index frag stats ahead of time by running with @PrepOnly = 1, then you can use this option. 
	@PrepOnly = 1, -- Valid options: 1, 0. Allows you to take frag stats earlier in the day and save them for use at a later time.
	@StmtOnly = 0, -- Print the reindex stmts w/o modifying the SP.  This will NOT run any reindex stmts, only PRINT them.
	@Include = 'Demo', -- Only do DBs listed here. Commas are used. ex: @Include = 'master, model, msdb'
	@Exclude = NULL, -- Do all DBs except the ones listed here. Commas are used. ex: @Exclude = 'master, model, msdb'
	@LogProgress = 1 -- Allows Live Insight through Log tables.

SELECT * FROM Minion.IndexTableFrag;

-----!!!Example ONLY!! Don't run!!!
EXEC [Minion].[IndexMaintMaster] 
	@IndexOption = 'All', -- Valid options: All, ONLINE, OFFLINE
	@ReorgMode = 'All', -- Valid options: All, Reorg, Rebuild
	@RunPrepped = 1, -- Valid options: 1, 0. If you've collected index frag stats ahead of time by running with @PrepOnly = 1, then you can use this option. 
	@PrepOnly = 0, -- Valid options: 1, 0. Allows you to take frag stats earlier in the day and save them for use at a later time.
	@StmtOnly = 0, -- Print the reindex stmts w/o modifying the SP.  This will NOT run any reindex stmts, only PRINT them.
	@Include = 'Demo', -- Only do DBs listed here. Commas are used. ex: @Include = 'master, model, msdb'
	@Exclude = NULL, -- Do all DBs except the ones listed here. Commas are used. ex: @Exclude = 'master, model, msdb'
	@LogProgress = 1 -- Allows Live Insight through Log tables.

-------------------------------------------------------------------------
-------------------------------------------------------------------------
------------------END Maximize Maint Window------------------------------
-------------------------------------------------------------------------
-------------------------------------------------------------------------



-------------------------------------------------------------------------
-------------------------------------------------------------------------
------------------BEGIN Recovery Model-----------------------------------
-------------------------------------------------------------------------
-------------------------------------------------------------------------

----A fully logged reindex can take a very long time.  Here we're going to switch 
----the recovery model to Bulk-logged before a single DB.  The rest of them will 
----stay as normal.
UPDATE Minion.IndexSettingsDB
SET RecoveryModel = 'BULK_LOGGED'
WHERE DBName = 'Demo'

BACKUP DATABASE Demo
TO disk = 'C:\MyBackups\Demo.bak'
WITH INIT, FORMAT, STATS = 5;

EXEC [Minion].[IndexMaintMaster] 
	@IndexOption = 'All', -- Valid options: All, ONLINE, OFFLINE
	@ReorgMode = 'All', -- Valid options: All, Reorg, Rebuild
	@RunPrepped = 0, -- Valid options: 1, 0. If you've collected index frag stats ahead of time by running with @PrepOnly = 1, then you can use this option. 
	@PrepOnly = 0, -- Valid options: 1, 0. Allows you to take frag stats earlier in the day and save them for use at a later time.
	@StmtOnly = 0, -- Print the reindex stmts w/o modifying the SP.  This will NOT run any reindex stmts, only PRINT them.
	@Include = 'Demo', -- Only do DBs listed here. Commas are used. ex: @Include = 'master, model, msdb'
	@Exclude = NULL, -- Do all DBs except the ones listed here. Commas are used. ex: @Exclude = 'master, model, msdb'
	@LogProgress = 1 -- Allows Live Insight through Log tables.


ALTER DATABASE Demo
SET SINGLE_USER WITH ROLLBACK IMMEDIATE

RESTORE DATABASE Demo
FROM disk = 'c:\MyBackups\Demo.bak'
WITH REPLACE, STATS = 5

SELECT * FROM Minion.IndexMaintLog ORDER BY ID DESC;
-------------------------------------------------------------------------
-------------------------------------------------------------------------
------------------END Recovery Model-------------------------------------
-------------------------------------------------------------------------
-------------------------------------------------------------------------



-------------------------------------------------------------------------
-------------------------------------------------------------------------
------------------BEGIN Log Frag Stats-----------------------------------
-------------------------------------------------------------------------
-------------------------------------------------------------------------

----Here we need to monitor the frag levels of our tables throughout the day so we can see how much they're fragmenting, or maybe just monitor a subset of tables
----so we can see at what times of the day they get fragged the most.
----This can really help you determine what your fillfactor should be and whether you need to adjust your run frequency.

UPDATE Minion.IndexSettingsDB
SET LogIndexPhysicalStats = 1
WHERE DBName = 'Demo'; 

--Start by running with PrepOnly
EXEC [Minion].[IndexMaintMaster] 
	@IndexOption = 'All', -- Valid options: All, ONLINE, OFFLINE
	@ReorgMode = 'All', -- Valid options: All, Reorg, Rebuild
	@RunPrepped = 0, -- Valid options: 1, 0. If you've collected index frag stats ahead of time by running with @PrepOnly = 1, then you can use this option. 
	@PrepOnly = 1, -- Valid options: 1, 0. Allows you to take frag stats earlier in the day and save them for use at a later time.
	@StmtOnly = 0, -- Print the reindex stmts w/o modifying the SP.  This will NOT run any reindex stmts, only PRINT them.
	@Include = 'Demo', -- Only do DBs listed here. Commas are used. ex: @Include = 'master, model, msdb'
	@Exclude = NULL, -- Do all DBs except the ones listed here. Commas are used. ex: @Exclude = 'master, model, msdb'
	@LogProgress = 1 -- Allows Live Insight through Log tables.

--Now you can inspect the data in each of the tables.
SELECT * FROM Minion.IndexSettingsDB;
SELECT * FROM Minion.IndexSettingsTable;
SELECT * FROM Minion.IndexTableFrag;
SELECT * FROM Minion.IndexPhysicalStats; 
TRUNCATE TABLE Minion.IndexPhysicalStats
--And since you're not interested in running the defrag right now, you're only interested in monitoring the stats, you can delete the TableFrag table.
DELETE Minion.IndexTableFrag
WHERE ExecutionDateTime IN (SELECT MAX(ExecutionDateTime) FROM Minion.IndexTableFrag)

--Right now you do have to put that into its own job and add those 2 steps.
	--Step1: Run PrepOnly.
	--Step2: Delete the TableFrag table.
	--Step3 (eventually): You'll need to delete rows out of the PhysicalStats table on your own schedule cause we don't do it for you.
-------------------------------------------------------------------------
-------------------------------------------------------------------------
------------------END Log Frag Stats-------------------------------------
-------------------------------------------------------------------------
-------------------------------------------------------------------------



-------------------------------------------------------------------------
-------------------------------------------------------------------------
------------------BEGIN Allow Page Locks---------------------------------
-------------------------------------------------------------------------
-------------------------------------------------------------------------

--This is a good one.  Our vendor requires us to keep page locks turned off for our tables.  However, you can't run defrags with this setting off cause
--they rely on page-level locking.  So we need a way to toggle the setting.
--So why is page locking turned off to begin with?  Quite often it's to reduce blocking and/or deadlocking. 

----------------------------
----BEGIN Setup scenario----
----------------------------
USE Demo;
GO
ALTER INDEX [ix_fragment2] ON [dbo].[Fragment1] SET ( ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = OFF )
ALTER INDEX [ix_fragment2] ON [dbo].[Fragment1] SET ( ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = OFF )
ALTER INDEX [PK__Fragment__3214EC277710CAB5] ON [dbo].[Fragment1] SET ( ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = OFF )
ALTER INDEX [ix_fragment2] ON [dbo].[Fragment2] SET ( ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = OFF )
ALTER INDEX [ix_fragment2] ON [dbo].[Fragment2] SET ( ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = OFF )
ALTER INDEX [PK__fragment__3214EC27621C84D0] ON [dbo].[Fragment2] SET ( ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = OFF )
USE PRECONDBMaint;
GO

DELETE Minion.IndexSettingsDB
WHERE ID > 1;

INSERT INTO Minion.IndexSettingsDB ([DBName], [Exclude], [ReindexGroupOrder], [ReindexOrder], [ReorgThreshold], [RebuildThreshold], [FILLFACTORopt], [PadIndex], [ONLINEopt], [SortInTempDB], [MAXDOPopt], [DataCompression], [GetRowCT], [GetPostFragLevel], [UpdateStatsOnDefrag], [StatScanOption], [IgnoreDupKey], [StatsNoRecompute], [AllowRowLocks], [AllowPageLocks], [WaitAtLowPriority], [MaxDurationInMins], [AbortAfterWait], [PushToMinion], [LogIndexPhysicalStats], [IndexScanMode], [DBPreCode], [DBPostCode], [TablePreCode], [TablePostCode], [LogProgress], [LogRetDays], [LogLoc], [MinionTriggerPath], [RecoveryModel], [IncludeUsageDetails]) 
SELECT 'Demo' AS [DBName], 0 AS [Exclude], 0 AS [ReindexGroupOrder], 0 AS [ReindexOrder], 1 AS [ReorgThreshold], 75 AS [RebuildThreshold], 90 AS [FILLFACTORopt], 'ON' AS [PadIndex], NULL AS [ONLINEopt], NULL AS [SortInTempDB], NULL AS [MAXDOPopt], NULL AS [DataCompression], 1 AS [GetRowCT], 1 AS [GetPostFragLevel], 1 AS [UpdateStatsOnDefrag], NULL AS [StatScanOption], NULL AS [IgnoreDupKey], NULL AS [StatsNoRecompute], NULL AS [AllowRowLocks], NULL AS [AllowPageLocks], NULL AS [WaitAtLowPriority], NULL AS [MaxDurationInMins], NULL AS [AbortAfterWait], NULL AS [PushToMinion], NULL AS [LogIndexPhysicalStats], NULL AS [IndexScanMode], NULL AS [DBPreCode], NULL AS [DBPostCode], NULL AS [TablePreCode], NULL AS [TablePostCode], 1 AS [LogProgress], 60 AS [LogRetDays], 'Local' AS [LogLoc], NULL AS [MinionTriggerPath], NULL AS [RecoveryModel], 1 AS [IncludeUsageDetails]

TRUNCATE TABLE Minion.IndexSettingsTable;

SELECT * FROM Minion.IndexSettingsDB

----------------------------
----END Setup scenario------
----------------------------


----------------------------
----BEGIN Initial Run-------
----------------------------
--This will fail because we're trying to do a defrag with page locks on.

BACKUP DATABASE Demo
TO disk = 'C:\MyBackups\Demo.bak'
WITH INIT, FORMAT, STATS = 5;

EXEC [Minion].[IndexMaintMaster] 
	@IndexOption = 'All', -- Valid options: All, ONLINE, OFFLINE
	@ReorgMode = 'All', -- Valid options: All, Reorg, Rebuild
	@RunPrepped = 0, -- Valid options: 1, 0. If you've collected index frag stats ahead of time by running with @PrepOnly = 1, then you can use this option. 
	@PrepOnly = 0, -- Valid options: 1, 0. Allows you to take frag stats earlier in the day and save them for use at a later time.
	@StmtOnly = 0, -- Print the reindex stmts w/o modifying the SP.  This will NOT run any reindex stmts, only PRINT them.
	@Include = 'Demo', -- Only do DBs listed here. Commas are used. ex: @Include = 'master, model, msdb'
	@Exclude = NULL, -- Do all DBs except the ones listed here. Commas are used. ex: @Exclude = 'master, model, msdb'
	@LogProgress = 1 -- Allows Live Insight through Log tables.

SELECT * FROM Minion.IndexMaintLogDetails ORDER BY ID DESC

ALTER DATABASE Demo
SET SINGLE_USER WITH ROLLBACK IMMEDIATE

RESTORE DATABASE Demo
FROM disk = 'c:\MyBackups\Demo.bak'
WITH REPLACE, STATS = 5
----------------------------
----END Initial Run---------
----------------------------

-------------------------------------------------------------------
--------------------BEGIN Insert Table Overrides-------------------
-------------------------------------------------------------------
-----Reset since DB was restored to orig state.
USE Demo;
GO
ALTER INDEX [ix_fragment2] ON [dbo].[Fragment1] SET ( ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = OFF )
ALTER INDEX [ix_fragment2] ON [dbo].[Fragment1] SET ( ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = OFF )
ALTER INDEX [PK__Fragment__3214EC277710CAB5] ON [dbo].[Fragment1] SET ( ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = OFF )
ALTER INDEX [ix_fragment2] ON [dbo].[Fragment2] SET ( ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = OFF )
ALTER INDEX [ix_fragment2] ON [dbo].[Fragment2] SET ( ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = OFF )
ALTER INDEX [PK__fragment__3214EC27621C84D0] ON [dbo].[Fragment2] SET ( ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = OFF )
USE PRECONDBMaint;
GO


USE Demo;
GO
WITH PrePostCodeAll(object_id, stmt_before, stmt_after) as
(
      Select  
            t.object_id,
            'ALTER index ' + QUOTENAME(i.name) + ' ON ' + SCHEMA_NAME(t.schema_id) + '.' + QUOTENAME(t.name) + ' SET (ALLOW_PAGE_LOCKS = ON)' as stmt_before,
            'ALTER index ' + QUOTENAME(i.name) + ' ON ' + SCHEMA_NAME(t.schema_id) + '.' + QUOTENAME(t.name) + ' SET (ALLOW_PAGE_LOCKS = OFF)' as stmt_after 
      from sys.tables t
      INNER JOIN sys.indexes i
            ON i.object_id = t.object_id
      WHERE allow_page_locks = 0
),PrePostCode(object_id, PreCode, PostCode) as 
(
      SELECT      DISTINCT object_id ,
            PreCode = 'USE ' + QuoteName(DB_NAME()) + ';' +
                        (SELECT stmt_before + ';'
                        FROM  PrePostCodeAll AS B2
                        WHERE B2.object_id = B1.object_id   
                        ORDER BY stmt_before
                        FOR XML     PATH('')
                        ),
            PostCode = 'USE ' + QuoteName(DB_NAME()) + ';' +
                        ( SELECT    stmt_after + ';'
                        FROM PrePostCodeAll AS B2
                        WHERE B2.object_id = B1.object_id   
                        ORDER BY stmt_before
                        FOR XML     PATH('')
                        )                       
      FROM PrePostCodeAll AS B1
)  
Select
      DB_NAME() as DBName ,  
      SCHEMA_NAME(t.schema_id) as SchemaName , 
      t.name as TableName, 
      p.object_id, 
      p.PreCode, 
      p.PostCode
INTO #TablesWithPageLocks
FROM PrePostCode p
INNER JOIN sys.tables t
      ON t.object_id = p.object_id;

SELECT * FROM #TablesWithPageLocks
--DROP TABLE #TablesWithPageLocks          
INSERT PRECONDBMaint.Minion.IndexSettingsTable (DBName, SchemaName, TableName, Exclude, ReindexGroupOrder, ReindexOrder, ReorgThreshold, RebuildThreshold, AllowPageLocks, TablePreCode, TablePostCode)
SELECT 
      DBName,
      SchemaName,
      TableName,
      0, --Exclude
      0, --ReindexGroupOrder
      0, --ReindexOrder
      10, --ReorgThreshold,
      20, --RebuildThreshold
      'ON',
      PreCode,
      PostCode
FROM #TablesWithPageLocks;
USE PRECONDBMaint;
GO
SELECT * FROM Minion.IndexSettingsTable;
-------------------------------------------------------------------
--------------------END Insert Table Overrides---------------------
-------------------------------------------------------------------

----------------------------
----BEGIN Fixed Run---------
----------------------------
--This will fail because we're trying to do a defrag with page locks on.


BACKUP DATABASE Demo
TO disk = 'C:\MyBackups\Demo.bak'
WITH INIT, FORMAT, STATS = 5;

EXEC [Minion].[IndexMaintMaster] 
	@IndexOption = 'All', -- Valid options: All, ONLINE, OFFLINE
	@ReorgMode = 'All', -- Valid options: All, Reorg, Rebuild
	@RunPrepped = 0, -- Valid options: 1, 0. If you've collected index frag stats ahead of time by running with @PrepOnly = 1, then you can use this option. 
	@PrepOnly = 0, -- Valid options: 1, 0. Allows you to take frag stats earlier in the day and save them for use at a later time.
	@StmtOnly = 0, -- Print the reindex stmts w/o modifying the SP.  This will NOT run any reindex stmts, only PRINT them.
	@Include = 'Demo', -- Only do DBs listed here. Commas are used. ex: @Include = 'master, model, msdb'
	@Exclude = NULL, -- Do all DBs except the ones listed here. Commas are used. ex: @Exclude = 'master, model, msdb'
	@LogProgress = 1 -- Allows Live Insight through Log tables.

SELECT * FROM Minion.IndexMaintLogDetails ORDER BY ID DESC

ALTER DATABASE Demo
SET SINGLE_USER WITH ROLLBACK IMMEDIATE

RESTORE DATABASE Demo
FROM disk = 'c:\MyBackups\Demo.bak'
WITH REPLACE, STATS = 5
----------------------------
----END Fixed Run-----------
----------------------------


-------------------------------------------------------------------------
-------------------------------------------------------------------------
------------------END Allow Page Locks-----------------------------------
-------------------------------------------------------------------------
-------------------------------------------------------------------------




-------------------------------------------------------------------------
-------------------------------------------------------------------------
------------------BEGIN Custom Thresholds--------------------------------
-------------------------------------------------------------------------
-------------------------------------------------------------------------
--It's not uncommon to need custom thresholds for specific tables.
TRUNCATE TABLE Minion.IndexSettingsTable;

DELETE Minion.IndexSettingsDB
WHERE ID > 1;

INSERT INTO Minion.IndexSettingsDB ([DBName], [Exclude], [ReindexGroupOrder], [ReindexOrder], [ReorgThreshold], [RebuildThreshold], [FILLFACTORopt], [PadIndex], [ONLINEopt], [SortInTempDB], [MAXDOPopt], [DataCompression], [GetRowCT], [GetPostFragLevel], [UpdateStatsOnDefrag], [StatScanOption], [IgnoreDupKey], [StatsNoRecompute], [AllowRowLocks], [AllowPageLocks], [WaitAtLowPriority], [MaxDurationInMins], [AbortAfterWait], [PushToMinion], [LogIndexPhysicalStats], [IndexScanMode], [DBPreCode], [DBPostCode], [TablePreCode], [TablePostCode], [LogProgress], [LogRetDays], [LogLoc], [MinionTriggerPath], [RecoveryModel], [IncludeUsageDetails]) 
SELECT 'Demo' AS [DBName], 0 AS [Exclude], 0 AS [ReindexGroupOrder], 0 AS [ReindexOrder], 5 AS [ReorgThreshold], 15 AS [RebuildThreshold], 90 AS [FILLFACTORopt], 'ON' AS [PadIndex], NULL AS [ONLINEopt], NULL AS [SortInTempDB], NULL AS [MAXDOPopt], NULL AS [DataCompression], 1 AS [GetRowCT], 1 AS [GetPostFragLevel], 1 AS [UpdateStatsOnDefrag], NULL AS [StatScanOption], NULL AS [IgnoreDupKey], NULL AS [StatsNoRecompute], NULL AS [AllowRowLocks], NULL AS [AllowPageLocks], NULL AS [WaitAtLowPriority], NULL AS [MaxDurationInMins], NULL AS [AbortAfterWait], NULL AS [PushToMinion], NULL AS [LogIndexPhysicalStats], NULL AS [IndexScanMode], NULL AS [DBPreCode], NULL AS [DBPostCode], NULL AS [TablePreCode], NULL AS [TablePostCode], 1 AS [LogProgress], 60 AS [LogRetDays], 'Local' AS [LogLoc], NULL AS [MinionTriggerPath], NULL AS [RecoveryModel], 1 AS [IncludeUsageDetails]
SELECT * FROM Minion.IndexSettingsDB

INSERT INTO Minion.IndexSettingsTable ([DBName], [SchemaName], [TableName], [Exclude], [ReindexGroupOrder], [ReindexOrder], [ReorgThreshold], [RebuildThreshold], [FILLFACTORopt], [PadIndex], [ONLINEopt], [SortInTempDB], [MAXDOPopt], [DataCompression], [GetRowCT], [GetPostFragLevel], [UpdateStatsOnDefrag], [StatScanOption], [IgnoreDupKey], [StatsNoRecompute], [AllowRowLocks], [AllowPageLocks], [WaitAtLowPriority], [MaxDurationInMins], [AbortAfterWait], [PushToMinion], [LogIndexPhysicalStats], [IndexScanMode], [TablePreCode], [TablePostCode], [LogProgress], [LogRetDays], [PartitionReindex], [isLOB], [TableType], [IncludeUsageDetails]) 
SELECT 'Demo' AS [DBName],
'dbo' AS [SchemaName],
'Fragment1' AS [TableName],
0 AS [Exclude],
10 AS [ReindexGroupOrder],
10 AS [ReindexOrder],
30 AS [ReorgThreshold],
50 AS [RebuildThreshold],
80 AS [FILLFACTORopt],
'ON' AS [PadIndex],
'ON' AS [ONLINEopt],
'ON' AS [SortInTempDB],
NULL AS [MAXDOPopt],
NULL AS [DataCompression],
1 AS [GetRowCT],
1 AS [GetPostFragLevel],
1 AS [UpdateStatsOnDefrag],
NULL AS [StatScanOption],
NULL AS [IgnoreDupKey],
NULL AS [StatsNoRecompute],
NULL AS [AllowRowLocks],
NULL AS [AllowPageLocks],
NULL AS [WaitAtLowPriority],
NULL AS [MaxDurationInMins],
NULL AS [AbortAfterWait],
NULL AS [PushToMinion],
NULL AS [LogIndexPhysicalStats],
NULL AS [IndexScanMode],
NULL AS [TablePreCode],
NULL AS [TablePostCode],
NULL AS [LogProgress],
NULL AS [LogRetDays],
NULL AS [PartitionReindex],
NULL AS [isLOB],
NULL AS [TableType],
1 AS [IncludeUsageDetails]

INSERT INTO Minion.IndexSettingsTable ([DBName], [SchemaName], [TableName], [Exclude], [ReindexGroupOrder], [ReindexOrder], [ReorgThreshold], [RebuildThreshold], [FILLFACTORopt], [PadIndex], [ONLINEopt], [SortInTempDB], [MAXDOPopt], [DataCompression], [GetRowCT], [GetPostFragLevel], [UpdateStatsOnDefrag], [StatScanOption], [IgnoreDupKey], [StatsNoRecompute], [AllowRowLocks], [AllowPageLocks], [WaitAtLowPriority], [MaxDurationInMins], [AbortAfterWait], [PushToMinion], [LogIndexPhysicalStats], [IndexScanMode], [TablePreCode], [TablePostCode], [LogProgress], [LogRetDays], [PartitionReindex], [isLOB], [TableType], [IncludeUsageDetails]) 
SELECT 'Demo' AS [DBName],
'dbo' AS [SchemaName],
'Fragment2' AS [TableName],
0 AS [Exclude],
0 AS [ReindexGroupOrder],
0 AS [ReindexOrder],
20 AS [ReorgThreshold],
35 AS [RebuildThreshold],
85 AS [FILLFACTORopt],
'ON' AS [PadIndex],
'ON' AS [ONLINEopt],
'ON' AS [SortInTempDB],
NULL AS [MAXDOPopt],
NULL AS [DataCompression],
1 AS [GetRowCT],
1 AS [GetPostFragLevel],
1 AS [UpdateStatsOnDefrag],
NULL AS [StatScanOption],
NULL AS [IgnoreDupKey],
NULL AS [StatsNoRecompute],
NULL AS [AllowRowLocks],
NULL AS [AllowPageLocks],
NULL AS [WaitAtLowPriority],
NULL AS [MaxDurationInMins],
NULL AS [AbortAfterWait],
NULL AS [PushToMinion],
NULL AS [LogIndexPhysicalStats],
NULL AS [IndexScanMode],
NULL AS [TablePreCode],
NULL AS [TablePostCode],
NULL AS [LogProgress],
NULL AS [LogRetDays],
NULL AS [PartitionReindex],
NULL AS [isLOB],
NULL AS [TableType],
1 AS [IncludeUsageDetails]

SELECT * FROM Minion.IndexSettingsTable;
-------------------------------------------------------------------------
-------------------------------------------------------------------------
------------------END Custom Thresholds----------------------------------
-------------------------------------------------------------------------
-------------------------------------------------------------------------




-------------------------------------------------------------------------
-------------------------------------------------------------------------
------------------BEGIN Custom ScanMode----------------------------------
-------------------------------------------------------------------------
-------------------------------------------------------------------------
--From time to time, we've seen where a default scan doesn't pick up the fragmentation because it doesn't read all levels of the index.
--In these cases you'll need to use a detailed scan.  For this, MR uses the max frag from all the levels to determine the frag level to be used.

----------------------------
----BEGIN Setup scenario----
----------------------------
TRUNCATE TABLE Minion.IndexSettingsTable;

DELETE Minion.IndexSettingsDB
WHERE ID > 1;

INSERT INTO Minion.IndexSettingsDB ([DBName], [Exclude], [ReindexGroupOrder], [ReindexOrder], [ReorgThreshold], [RebuildThreshold], [FILLFACTORopt], [PadIndex], [ONLINEopt], [SortInTempDB], [MAXDOPopt], [DataCompression], [GetRowCT], [GetPostFragLevel], [UpdateStatsOnDefrag], [StatScanOption], [IgnoreDupKey], [StatsNoRecompute], [AllowRowLocks], [AllowPageLocks], [WaitAtLowPriority], [MaxDurationInMins], [AbortAfterWait], [PushToMinion], [LogIndexPhysicalStats], [IndexScanMode], [DBPreCode], [DBPostCode], [TablePreCode], [TablePostCode], [LogProgress], [LogRetDays], [LogLoc], [MinionTriggerPath], [RecoveryModel], [IncludeUsageDetails]) 
SELECT 'Demo' AS [DBName], 0 AS [Exclude], 0 AS [ReindexGroupOrder], 0 AS [ReindexOrder], 5 AS [ReorgThreshold], 15 AS [RebuildThreshold], 90 AS [FILLFACTORopt], 'ON' AS [PadIndex], NULL AS [ONLINEopt], NULL AS [SortInTempDB], NULL AS [MAXDOPopt], NULL AS [DataCompression], 1 AS [GetRowCT], 1 AS [GetPostFragLevel], 1 AS [UpdateStatsOnDefrag], NULL AS [StatScanOption], NULL AS [IgnoreDupKey], NULL AS [StatsNoRecompute], NULL AS [AllowRowLocks], NULL AS [AllowPageLocks], NULL AS [WaitAtLowPriority], NULL AS [MaxDurationInMins], NULL AS [AbortAfterWait], NULL AS [PushToMinion], NULL AS [LogIndexPhysicalStats], NULL AS [IndexScanMode], NULL AS [DBPreCode], NULL AS [DBPostCode], NULL AS [TablePreCode], NULL AS [TablePostCode], 1 AS [LogProgress], 60 AS [LogRetDays], 'Local' AS [LogLoc], NULL AS [MinionTriggerPath], NULL AS [RecoveryModel], 1 AS [IncludeUsageDetails]
SELECT * FROM Minion.IndexSettingsDB

INSERT INTO Minion.IndexSettingsTable ([DBName], [SchemaName], [TableName], [Exclude], [ReindexGroupOrder], [ReindexOrder], [ReorgThreshold], [RebuildThreshold], [FILLFACTORopt], [PadIndex], [ONLINEopt], [SortInTempDB], [MAXDOPopt], [DataCompression], [GetRowCT], [GetPostFragLevel], [UpdateStatsOnDefrag], [StatScanOption], [IgnoreDupKey], [StatsNoRecompute], [AllowRowLocks], [AllowPageLocks], [WaitAtLowPriority], [MaxDurationInMins], [AbortAfterWait], [PushToMinion], [LogIndexPhysicalStats], [IndexScanMode], [TablePreCode], [TablePostCode], [LogProgress], [LogRetDays], [PartitionReindex], [isLOB], [TableType], [IncludeUsageDetails]) 
SELECT 'Demo' AS [DBName],
'dbo' AS [SchemaName],
'Fragment1' AS [TableName],
0 AS [Exclude],
10 AS [ReindexGroupOrder],
10 AS [ReindexOrder],
30 AS [ReorgThreshold],
50 AS [RebuildThreshold],
80 AS [FILLFACTORopt],
'ON' AS [PadIndex],
'ON' AS [ONLINEopt],
'ON' AS [SortInTempDB],
NULL AS [MAXDOPopt],
NULL AS [DataCompression],
1 AS [GetRowCT],
1 AS [GetPostFragLevel],
1 AS [UpdateStatsOnDefrag],
NULL AS [StatScanOption],
NULL AS [IgnoreDupKey],
NULL AS [StatsNoRecompute],
NULL AS [AllowRowLocks],
NULL AS [AllowPageLocks],
NULL AS [WaitAtLowPriority],
NULL AS [MaxDurationInMins],
NULL AS [AbortAfterWait],
NULL AS [PushToMinion],
NULL AS [LogIndexPhysicalStats],
'DETAILED' AS [IndexScanMode],
NULL AS [TablePreCode],
NULL AS [TablePostCode],
NULL AS [LogProgress],
NULL AS [LogRetDays],
NULL AS [PartitionReindex],
NULL AS [isLOB],
NULL AS [TableType],
1 AS [IncludeUsageDetails]

INSERT INTO Minion.IndexSettingsTable ([DBName], [SchemaName], [TableName], [Exclude], [ReindexGroupOrder], [ReindexOrder], [ReorgThreshold], [RebuildThreshold], [FILLFACTORopt], [PadIndex], [ONLINEopt], [SortInTempDB], [MAXDOPopt], [DataCompression], [GetRowCT], [GetPostFragLevel], [UpdateStatsOnDefrag], [StatScanOption], [IgnoreDupKey], [StatsNoRecompute], [AllowRowLocks], [AllowPageLocks], [WaitAtLowPriority], [MaxDurationInMins], [AbortAfterWait], [PushToMinion], [LogIndexPhysicalStats], [IndexScanMode], [TablePreCode], [TablePostCode], [LogProgress], [LogRetDays], [PartitionReindex], [isLOB], [TableType], [IncludeUsageDetails]) 
SELECT 'Demo' AS [DBName],
'dbo' AS [SchemaName],
'Fragment2' AS [TableName],
0 AS [Exclude],
0 AS [ReindexGroupOrder],
0 AS [ReindexOrder],
20 AS [ReorgThreshold],
35 AS [RebuildThreshold],
85 AS [FILLFACTORopt],
'ON' AS [PadIndex],
'ON' AS [ONLINEopt],
'ON' AS [SortInTempDB],
NULL AS [MAXDOPopt],
NULL AS [DataCompression],
1 AS [GetRowCT],
1 AS [GetPostFragLevel],
1 AS [UpdateStatsOnDefrag],
NULL AS [StatScanOption],
NULL AS [IgnoreDupKey],
NULL AS [StatsNoRecompute],
NULL AS [AllowRowLocks],
NULL AS [AllowPageLocks],
NULL AS [WaitAtLowPriority],
NULL AS [MaxDurationInMins],
NULL AS [AbortAfterWait],
NULL AS [PushToMinion],
NULL AS [LogIndexPhysicalStats],
'DETAILED' AS [IndexScanMode],
NULL AS [TablePreCode],
NULL AS [TablePostCode],
NULL AS [LogProgress],
NULL AS [LogRetDays],
NULL AS [PartitionReindex],
NULL AS [isLOB],
NULL AS [TableType],
1 AS [IncludeUsageDetails]

----The page locks are still off from the last demo so reset them now.
USE Demo;
GO
ALTER INDEX [ix_fragment2] ON [dbo].[Fragment1] SET ( ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON )
ALTER INDEX [ix_fragment2] ON [dbo].[Fragment1] SET ( ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON )
ALTER INDEX [PK__Fragment__3214EC277710CAB5] ON [dbo].[Fragment1] SET ( ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON )
ALTER INDEX [ix_fragment2] ON [dbo].[Fragment2] SET ( ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON )
ALTER INDEX [ix_fragment2] ON [dbo].[Fragment2] SET ( ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON )
ALTER INDEX [PK__fragment__3214EC27621C84D0] ON [dbo].[Fragment2] SET ( ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON )
USE PRECONDBMaint;
GO

SELECT * FROM Minion.IndexSettingsTable;
----------------------------
----END Setup scenario------
----------------------------

BACKUP DATABASE Demo
TO disk = 'C:\MyBackups\Demo.bak'
WITH INIT, FORMAT, STATS = 5;

EXEC [Minion].[IndexMaintMaster] 
	@IndexOption = 'All', -- Valid options: All, ONLINE, OFFLINE
	@ReorgMode = 'All', -- Valid options: All, Reorg, Rebuild
	@RunPrepped = 0, -- Valid options: 1, 0. If you've collected index frag stats ahead of time by running with @PrepOnly = 1, then you can use this option. 
	@PrepOnly = 0, -- Valid options: 1, 0. Allows you to take frag stats earlier in the day and save them for use at a later time.
	@StmtOnly = 0, -- Print the reindex stmts w/o modifying the SP.  This will NOT run any reindex stmts, only PRINT them.
	@Include = 'Demo', -- Only do DBs listed here. Commas are used. ex: @Include = 'master, model, msdb'
	@Exclude = NULL, -- Do all DBs except the ones listed here. Commas are used. ex: @Exclude = 'master, model, msdb'
	@LogProgress = 1 -- Allows Live Insight through Log tables.

SELECT ExecutionDateTime, Status, DBName, SchemaName, TableName, IndexName,IndexScanMode FROM Minion.IndexMaintLogDetails ORDER BY ID DESC

ALTER DATABASE Demo
SET SINGLE_USER WITH ROLLBACK IMMEDIATE

RESTORE DATABASE Demo
FROM disk = 'c:\MyBackups\Demo.bak'
WITH REPLACE, STATS = 5
-------------------------------------------------------------------------
-------------------------------------------------------------------------
------------------END Custom ScanMode------------------------------------
-------------------------------------------------------------------------
-------------------------------------------------------------------------


-------------------------------------------------------------------------
-------------------------------------------------------------------------
------------------BEGIN Dynamic Delete on Rowcount-----------------------
-------------------------------------------------------------------------
-------------------------------------------------------------------------

DELETE Minion.IndexSettingsDB
WHERE ID > 1;

UPDATE Minion.IndexSettingsDB
SET LogIndexPhysicalStats = 1,
	IndexScanMode = 'DETAILED'

SELECT * FROM Minion.IndexSettingsDB

----------------------BEGIN Reset table------------------------
TRUNCATE TABLE [Minion].IndexTableFrag

----Either run this, or the PrepOnly call below. No need to run both.
INSERT [Minion].IndexTableFrag
SELECT * FROM [Minion].IndexTableFragBackup

SELECT * FROM [Minion].IndexTableFrag
--There are 13103 rows.
-----------------------END Reset Table-------------------------


EXEC [Minion].[IndexMaintMaster] 
	@IndexOption = 'All', -- Valid options: All, ONLINE, OFFLINE
	@ReorgMode = 'All', -- Valid options: All, Reorg, Rebuild
	@RunPrepped = 0, -- Valid options: 1, 0. If you've collected index frag stats ahead of time by running with @PrepOnly = 1, then you can use this option. 
	@PrepOnly = 1, -- Valid options: 1, 0. Allows you to take frag stats earlier in the day and save them for use at a later time.
	@StmtOnly = 0, -- Print the reindex stmts w/o modifying the SP.  This will NOT run any reindex stmts, only PRINT them.
	@Include = NULL, -- Only do DBs listed here. Commas are used. ex: @Include = 'master, model, msdb'
	@Exclude = NULL, -- Do all DBs except the ones listed here. Commas are used. ex: @Exclude = 'master, model, msdb'
	@LogProgress = 1 -- Allows Live Insight through Log tables.

----ALTER INDEX ALL ON Minion.IndexTableFrag REBUILD
	----This is the precode you'll run to limit the indexes processed.
	EXEC Minion.IndexMaintFilter @OverRowcount=5000 -- @StmtOnly = 1;

SELECT * FROM [Minion].IndexTableFrag
-------------------------------------------------------------------------
-------------------------------------------------------------------------
------------------END Dynamic Delete on Rowcount-------------------------
-------------------------------------------------------------------------
-------------------------------------------------------------------------





-------------------------------------------------------------------------
-------------------------------------------------------------------------
------------------BEGIN Dynamic Delete on Table pagecount----------------
-------------------------------------------------------------------------
-------------------------------------------------------------------------

DELETE Minion.IndexSettingsDB
WHERE ID > 1;

UPDATE Minion.IndexSettingsDB
SET LogIndexPhysicalStats = 1,
	IndexScanMode = 'DETAILED'

SELECT * FROM Minion.IndexSettingsDB

----------------------BEGIN Reset table------------------------
TRUNCATE TABLE [Minion].IndexTableFrag

----Either run this, or the PrepOnly call below. No need to run both.
INSERT [Minion].IndexTableFrag
SELECT * FROM [Minion].IndexTableFragBackup

SELECT * FROM [Minion].IndexTableFrag
--There are 13103 rows.
-----------------------END Reset Table-------------------------

EXEC [Minion].[IndexMaintMaster] 
	@IndexOption = 'All', -- Valid options: All, ONLINE, OFFLINE
	@ReorgMode = 'All', -- Valid options: All, Reorg, Rebuild
	@RunPrepped = 0, -- Valid options: 1, 0. If you've collected index frag stats ahead of time by running with @PrepOnly = 1, then you can use this option. 
	@PrepOnly = 1, -- Valid options: 1, 0. Allows you to take frag stats earlier in the day and save them for use at a later time.
	@StmtOnly = 0, -- Print the reindex stmts w/o modifying the SP.  This will NOT run any reindex stmts, only PRINT them.
	@Include = 'Minion', -- Only do DBs listed here. Commas are used. ex: @Include = 'master, model, msdb'
	@Exclude = NULL, -- Do all DBs except the ones listed here. Commas are used. ex: @Exclude = 'master, model, msdb'
	@LogProgress = 1 -- Allows Live Insight through Log tables.

	----This is the precode you'll run to limit the indexes processed.
	EXEC Minion.IndexMaintFilter @OverPagecount=1000;

SELECT * FROM [Minion].IndexTableFrag
-------------------------------------------------------------------------
-------------------------------------------------------------------------
------------------END Dynamic Delete on Table pagecount------------------
-------------------------------------------------------------------------
-------------------------------------------------------------------------



-------------------------------------------------------------------------
-------------------------------------------------------------------------
------------------BEGIN Dynamic Delete on Index pagecount----------------
-------------------------------------------------------------------------
-------------------------------------------------------------------------

DELETE Minion.IndexSettingsDB
WHERE ID > 1;

UPDATE Minion.IndexSettingsDB
SET LogIndexPhysicalStats = 1,
	IndexScanMode = 'DETAILED'

SELECT * FROM Minion.IndexSettingsDB

----------------------BEGIN Reset table------------------------
TRUNCATE TABLE [Minion].IndexTableFrag

----Either run this, or the PrepOnly call below. No need to run both.
INSERT [Minion].IndexTableFrag
SELECT * FROM [Minion].IndexTableFragBackup

SELECT * FROM [Minion].IndexTableFrag
--There are 13103 rows.
-----------------------END Reset Table-------------------------

EXEC [Minion].[IndexMaintMaster] 
	@IndexOption = 'All', -- Valid options: All, ONLINE, OFFLINE
	@ReorgMode = 'All', -- Valid options: All, Reorg, Rebuild
	@RunPrepped = 0, -- Valid options: 1, 0. If you've collected index frag stats ahead of time by running with @PrepOnly = 1, then you can use this option. 
	@PrepOnly = 1, -- Valid options: 1, 0. Allows you to take frag stats earlier in the day and save them for use at a later time.
	@StmtOnly = 0, -- Print the reindex stmts w/o modifying the SP.  This will NOT run any reindex stmts, only PRINT them.
	@Include = NULL, -- Only do DBs listed here. Commas are used. ex: @Include = 'master, model, msdb'
	@Exclude = NULL, -- Do all DBs except the ones listed here. Commas are used. ex: @Exclude = 'master, model, msdb'
	@LogProgress = 1 -- Allows Live Insight through Log tables.

	----This is the precode you'll run to limit the indexes processed.
	EXEC Minion.IndexMaintFilter @OverIndexPagecount=1000 WITH RECOMPILE;

SELECT * FROM [Minion].IndexTableFrag
-------------------------------------------------------------------------
-------------------------------------------------------------------------
------------------END Dynamic Delete on Index pagecount------------------
-------------------------------------------------------------------------
-------------------------------------------------------------------------



-------------------------------------------------------------------------
-------------------------------------------------------------------------
------------------BEGIN Dynamic Order by Index Usage---------------------
-------------------------------------------------------------------------
-------------------------------------------------------------------------

DELETE Minion.IndexSettingsDB
WHERE ID > 1;

UPDATE Minion.IndexSettingsDB
SET LogIndexPhysicalStats = 1,
	IndexScanMode = 'DETAILED'

SELECT * FROM Minion.IndexSettingsDB

----------------------BEGIN Reset table------------------------
TRUNCATE TABLE [Minion].IndexTableFrag

----Either run this, or the PrepOnly call below. No need to run both.
INSERT [Minion].IndexTableFrag
SELECT * FROM [Minion].IndexTableFragBackup

SELECT * FROM [Minion].IndexTableFrag
WHERE DBName = 'Minion'
--There are 13070 rows.
-----------------------END Reset Table-------------------------

EXEC [Minion].[IndexMaintMaster] 
	@IndexOption = 'All', -- Valid options: All, ONLINE, OFFLINE
	@ReorgMode = 'All', -- Valid options: All, Reorg, Rebuild
	@RunPrepped = 0, -- Valid options: 1, 0. If you've collected index frag stats ahead of time by running with @PrepOnly = 1, then you can use this option. 
	@PrepOnly = 1, -- Valid options: 1, 0. Allows you to take frag stats earlier in the day and save them for use at a later time.
	@StmtOnly = 0, -- Print the reindex stmts w/o modifying the SP.  This will NOT run any reindex stmts, only PRINT them.
	@Include = NULL, -- Only do DBs listed here. Commas are used. ex: @Include = 'master, model, msdb'
	@Exclude = NULL, -- Do all DBs except the ones listed here. Commas are used. ex: @Exclude = 'master, model, msdb'
	@LogProgress = 1 -- Allows Live Insight through Log tables.

	----This is the precode you'll run to limit the indexes processed.
	EXEC Minion.IndexMaintHighUseFirst @DBName = 'Minion';

------Now compare these 2 queries to see how the ordering has changed based off of table usage.
SELECT * FROM [Minion].IndexTableFrag
WHERE DBName = 'Minion' 
SELECT * FROM [Minion].IndexTableFrag
WHERE DBName = 'Minion' 
ORDER BY ReindexGroupOrder DESC, ReindexOrder DESC


----Now, this precode works off of the index_usage_stats DMV and that can have some surprising results.  For instance, if you burped SQL recently, then you may not have honest stats
---here, so you may be better off going by the LogDetails table either for the last run or for a sum of the last month even.


-------------------------------------------------------------------------
-------------------------------------------------------------------------
------------------END Dynamic Order by Index Usage-----------------------
-------------------------------------------------------------------------
-------------------------------------------------------------------------



-------------------------------------------------------------------------
-------------------------------------------------------------------------
------------------BEGIN Dynamic Delete by Schema-------------------------
-------------------------------------------------------------------------
-------------------------------------------------------------------------

DELETE Minion.IndexSettingsDB
WHERE ID > 1;

UPDATE Minion.IndexSettingsDB
SET LogIndexPhysicalStats = 1,
	IndexScanMode = 'DETAILED'

SELECT * FROM Minion.IndexSettingsDB

----------------------BEGIN Reset table------------------------
TRUNCATE TABLE [Minion].IndexTableFrag

----Either run this, or the PrepOnly call below. No need to run both.
INSERT [Minion].IndexTableFrag
SELECT * FROM [Minion].IndexTableFragBackup

SELECT * FROM [Minion].IndexTableFrag WHERE DBName = 'Minion'
--There are 13070 rows.
-----------------------END Reset Table-------------------------

EXEC [Minion].[IndexMaintMaster] 
	@IndexOption = 'All', -- Valid options: All, ONLINE, OFFLINE
	@ReorgMode = 'All', -- Valid options: All, Reorg, Rebuild
	@RunPrepped = 0, -- Valid options: 1, 0. If you've collected index frag stats ahead of time by running with @PrepOnly = 1, then you can use this option. 
	@PrepOnly = 1, -- Valid options: 1, 0. Allows you to take frag stats earlier in the day and save them for use at a later time.
	@StmtOnly = 0, -- Print the reindex stmts w/o modifying the SP.  This will NOT run any reindex stmts, only PRINT them.
	@Include = NULL, -- Only do DBs listed here. Commas are used. ex: @Include = 'master, model, msdb'
	@Exclude = NULL, -- Do all DBs except the ones listed here. Commas are used. ex: @Exclude = 'master, model, msdb'
	@LogProgress = 1 -- Allows Live Insight through Log tables.

	----This is the precode you'll run to limit the indexes processed.
	DELETE FROM [Minion].IndexTableFrag
	WHERE DBName = 'Minion'
		  AND SchemaName IN ('dbo');

------Now compare these 2 queries to see the schemas have been deleted.
SELECT * FROM [Minion].IndexTableFrag
WHERE DBName = 'Minion' 

-------------------------------------------------------------------------
-------------------------------------------------------------------------
------------------END Dynamic Delete by Schema---------------------------
-------------------------------------------------------------------------
-------------------------------------------------------------------------




-------------------------------------------------------------------------
-------------------------------------------------------------------------
------------------BEGIN Dynamic SortInTempDB-----------------------------
-------------------------------------------------------------------------
-------------------------------------------------------------------------

--Why would you want to dynamically SortInTempdb?  Because if you've got a lot of tempdb usage and you don't want to add too much to the disk you don't want to run every reindex through there.
--But you may need to run your largest tables through there cause they're too big for your DB disk.

DELETE Minion.IndexSettingsDB
WHERE ID > 1;

UPDATE Minion.IndexSettingsDB
SET LogIndexPhysicalStats = 1,
	SortInTempDB = 0,
	IndexScanMode = 'DETAILED'

SELECT * FROM Minion.IndexSettingsDB

----------------------BEGIN Reset table------------------------
TRUNCATE TABLE [Minion].IndexTableFrag

----Either run this, or the PrepOnly call below. No need to run both.
INSERT [Minion].IndexTableFrag
SELECT * FROM [Minion].IndexTableFragBackup

SELECT * FROM [Minion].IndexTableFrag
--There are 13070 rows.
-----------------------END Reset Table-------------------------

EXEC [Minion].[IndexMaintMaster] 
	@IndexOption = 'All', -- Valid options: All, ONLINE, OFFLINE
	@ReorgMode = 'All', -- Valid options: All, Reorg, Rebuild
	@RunPrepped = 0, -- Valid options: 1, 0. If you've collected index frag stats ahead of time by running with @PrepOnly = 1, then you can use this option. 
	@PrepOnly = 1, -- Valid options: 1, 0. Allows you to take frag stats earlier in the day and save them for use at a later time.
	@StmtOnly = 0, -- Print the reindex stmts w/o modifying the SP.  This will NOT run any reindex stmts, only PRINT them.
	@Include = NULL, -- Only do DBs listed here. Commas are used. ex: @Include = 'master, model, msdb'
	@Exclude = NULL, -- Do all DBs except the ones listed here. Commas are used. ex: @Exclude = 'master, model, msdb'
	@LogProgress = 1 -- Allows Live Insight through Log tables.

	----This is the precode you'll run to limit the indexes processed.
CREATE TABLE #Results
(
objectID BIGINT,
DBName VARCHAR(400),
SchemaName VARCHAR(100),
TableName VARCHAR(100),
IndexID INT,
IndexName VARCHAR(200)
)

INSERT #Results
        (objectID, DBName, SchemaName, TableName, IndexID, IndexName)
EXEC Minion.IndexMaintFilter @OverRowcount=1000 WITH RECOMPILE;

UPDATE Minion.IndexTableFrag
SET SortInTempDB = 1
WHERE								!!!!!!Need TO complete!!!!!!
SELECT * FROM #Results;
DROP TABLE #Results
------Now compare these 2 queries to see the schemas have been deleted.
SELECT * FROM [Minion].IndexTableFrag
WHERE DBName = 'Minion' 

-------------------------------------------------------------------------
-------------------------------------------------------------------------
------------------END Dynamic SortInTempDB-------------------------------
-------------------------------------------------------------------------
-------------------------------------------------------------------------





-------------------------------------------------------------------------
-------------------------------------------------------------------------
------------------BEGIN Dynamic Order by Schema--------------------------
-------------------------------------------------------------------------
-------------------------------------------------------------------------

--You may want to order by schema as well if you know you've got schemas that are busier than others.
--This example only does ASC or DESC, but the order can be changed fairly easily.

DELETE Minion.IndexSettingsDB
WHERE ID > 1;

UPDATE Minion.IndexSettingsDB
SET LogIndexPhysicalStats = 1,
	SortInTempDB = 0,
	IndexScanMode = 'DETAILED'

SELECT * FROM Minion.IndexSettingsDB

----------------------BEGIN Reset table------------------------
TRUNCATE TABLE [Minion].IndexTableFrag

----Either run this, or the PrepOnly call below. No need to run both.
INSERT [Minion].IndexTableFrag
SELECT * FROM [Minion].IndexTableFragBackup

SELECT * FROM [Minion].IndexTableFrag
--There are 13070 rows.
-----------------------END Reset Table-------------------------

EXEC [Minion].[IndexMaintMaster] 
	@IndexOption = 'All', -- Valid options: All, ONLINE, OFFLINE
	@ReorgMode = 'All', -- Valid options: All, Reorg, Rebuild
	@RunPrepped = 0, -- Valid options: 1, 0. If you've collected index frag stats ahead of time by running with @PrepOnly = 1, then you can use this option. 
	@PrepOnly = 1, -- Valid options: 1, 0. Allows you to take frag stats earlier in the day and save them for use at a later time.
	@StmtOnly = 0, -- Print the reindex stmts w/o modifying the SP.  This will NOT run any reindex stmts, only PRINT them.
	@Include = NULL, -- Only do DBs listed here. Commas are used. ex: @Include = 'master, model, msdb'
	@Exclude = NULL, -- Do all DBs except the ones listed here. Commas are used. ex: @Exclude = 'master, model, msdb'
	@LogProgress = 1 -- Allows Live Insight through Log tables.

	----This is the precode you'll run to limit the indexes processed.

EXEC [Minion].[IndexMaintOrderBySchema] @DBName = 'Minion', @SchemaOrder = 'ASC';

------Now compare these 2 queries to see how the ordering has changed based off of table usage.
SELECT * FROM [Minion].IndexTableFrag
WHERE DBName = 'Minion' 
SELECT * FROM [Minion].IndexTableFrag
WHERE DBName = 'Minion' 
ORDER BY ReindexGroupOrder DESC, ReindexOrder DESC 

-------------------------------------------------------------------------
-------------------------------------------------------------------------
------------------END Dynamic Order by Schema----------------------------
-------------------------------------------------------------------------
-------------------------------------------------------------------------



-------------------------------------------------------------------------
-------------------------------------------------------------------------
------------------BEGIN Dynamic Drop_Existing----------------------------
-------------------------------------------------------------------------
-------------------------------------------------------------------------
--!!!!!!!!!!!!!Rework this... you'll just delete the big tables, and then use precode to run create index stmts for them instead.

--This is a rare situation, but we've seen it a few times.  
--In this scenario, the table and its indexes are too large to be rebuilt.  A rebuild always fails due to space.
--So the only recourse here is to create the index with drop_existing.
--You won't need this hardly ever, but it's good to know something like this exists when you need it, and that it's possible to do dynamically.

DELETE Minion.IndexSettingsDB
WHERE ID > 1;

UPDATE Minion.IndexSettingsDB
SET LogIndexPhysicalStats = 1,
	SortInTempDB = 0,
	IndexScanMode = 'DETAILED'

SELECT * FROM Minion.IndexSettingsDB

----------------------BEGIN Reset table------------------------
TRUNCATE TABLE [Minion].IndexTableFrag

----Either run this, or the PrepOnly call below. No need to run both.
INSERT [Minion].IndexTableFrag
SELECT * FROM [Minion].IndexTableFragBackup

SELECT * FROM [Minion].IndexTableFrag
--There are 13070 rows.
-----------------------END Reset Table-------------------------

EXEC [Minion].[IndexMaintMaster] 
	@IndexOption = 'All', -- Valid options: All, ONLINE, OFFLINE
	@ReorgMode = 'All', -- Valid options: All, Reorg, Rebuild
	@RunPrepped = 0, -- Valid options: 1, 0. If you've collected index frag stats ahead of time by running with @PrepOnly = 1, then you can use this option. 
	@PrepOnly = 1, -- Valid options: 1, 0. Allows you to take frag stats earlier in the day and save them for use at a later time.
	@StmtOnly = 0, -- Print the reindex stmts w/o modifying the SP.  This will NOT run any reindex stmts, only PRINT them.
	@Include = 'Minion', -- Only do DBs listed here. Commas are used. ex: @Include = 'master, model, msdb'
	@Exclude = NULL, -- Do all DBs except the ones listed here. Commas are used. ex: @Exclude = 'master, model, msdb'
	@LogProgress = 1 -- Allows Live Insight through Log tables.

	----This is the precode you'll run to limit the indexes processed.


------Now compare these 2 queries to see how the ordering has changed based off of table usage.
SELECT * FROM [Minion].IndexTableFrag
WHERE DBName = 'Minion' 


-------------------------------------------------------------------------
-------------------------------------------------------------------------
------------------END Dynamic Drop_Existing----------------------------
-------------------------------------------------------------------------
-------------------------------------------------------------------------


diff reporting scenarios.



